/* autostart-manager.c generated by valac 0.36.12, the Vala compiler
 * generated from autostart-manager.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/*
 * A simple class for manipulating autostarting Geary as a hidden application through a simple
 * desktop file at $HOME/.config/autostart/geary.desktop
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define TYPE_AUTOSTART_MANAGER (autostart_manager_get_type ())
#define AUTOSTART_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AUTOSTART_MANAGER, AutostartManager))
#define AUTOSTART_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AUTOSTART_MANAGER, AutostartManagerClass))
#define IS_AUTOSTART_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AUTOSTART_MANAGER))
#define IS_AUTOSTART_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AUTOSTART_MANAGER))
#define AUTOSTART_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AUTOSTART_MANAGER, AutostartManagerClass))

typedef struct _AutostartManager AutostartManager;
typedef struct _AutostartManagerClass AutostartManagerClass;
typedef struct _AutostartManagerPrivate AutostartManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AutostartManager {
	GObject parent_instance;
	AutostartManagerPrivate * priv;
};

struct _AutostartManagerClass {
	GObjectClass parent_class;
};

struct _AutostartManagerPrivate {
	GFile* startup_file;
};


static gpointer autostart_manager_parent_class = NULL;

GType autostart_manager_get_type (void) G_GNUC_CONST;
#define AUTOSTART_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_AUTOSTART_MANAGER, AutostartManagerPrivate))
enum  {
	AUTOSTART_MANAGER_0_PROPERTY
};
#define AUTOSTART_MANAGER_AUTOSTART_FOLDER "autostart"
#define AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE "geary-autostart.desktop"
AutostartManager* autostart_manager_new (void);
AutostartManager* autostart_manager_construct (GType object_type);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void) G_GNUC_DEPRECATED;
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_configuration (GValue* value, gpointer v_object);
void value_take_configuration (GValue* value, gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
Configuration* geary_application_get_config (GearyApplication* self);
GSettings* configuration_get_settings (Configuration* self);
#define CONFIGURATION_STARTUP_NOTIFICATIONS_KEY "startup-notifications"
void autostart_manager_on_startup_notification_change (AutostartManager* self);
static void _autostart_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
GFile* autostart_manager_get_autostart_desktop_file (AutostartManager* self);
GFile* geary_application_get_install_dir (GearyApplication* self);
#define GEARY_APPLICATION_SOURCE_ROOT_DIR _SOURCE_ROOT_DIR
void autostart_manager_delete_startup_file (AutostartManager* self);
void autostart_manager_create_startup_file (AutostartManager* self);
gboolean configuration_get_startup_notifications (Configuration* self);
void autostart_manager_sync_with_config (AutostartManager* self);
void configuration_set_startup_notifications (Configuration* self, gboolean value);
static void autostart_manager_finalize (GObject * obj);


static void _autostart_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	autostart_manager_on_startup_notification_change ((AutostartManager*) self);
#line 110 "autostart-manager.c"
}


AutostartManager* autostart_manager_construct (GType object_type) {
	AutostartManager * self = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GearyApplication* _tmp6_;
	GearyApplication* _tmp7_;
	Configuration* _tmp8_;
	Configuration* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	gchar* _tmp12_;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	self = (AutostartManager*) g_object_new (object_type, NULL);
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp2_ = _tmp1_;
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp3_ = g_file_get_child (_tmp2_, AUTOSTART_MANAGER_AUTOSTART_FOLDER);
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp4_ = _tmp3_;
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp5_ = g_file_get_child (_tmp4_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_object_unref0 (self->priv->startup_file);
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	self->priv->startup_file = _tmp5_;
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_object_unref0 (_tmp4_);
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_object_unref0 (_tmp2_);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp6_ = geary_application_get_instance ();
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp7_ = _tmp6_;
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp8_ = geary_application_get_config (_tmp7_);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp9_ = _tmp8_;
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp10_ = configuration_get_settings (_tmp9_);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp11_ = _tmp10_;
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp12_ = g_strconcat ("changed::", CONFIGURATION_STARTUP_NOTIFICATIONS_KEY, NULL);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	g_signal_connect_object (_tmp11_, _tmp12_, (GCallback) _autostart_manager_on_startup_notification_change_g_settings_changed, self, 0);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_free0 (_tmp12_);
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	return self;
#line 171 "autostart-manager.c"
}


AutostartManager* autostart_manager_new (void) {
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	return autostart_manager_construct (TYPE_AUTOSTART_MANAGER);
#line 178 "autostart-manager.c"
}


/**
     * Returns the system-wide autostart desktop file
     */
static gpointer _g_object_ref0 (gpointer self) {
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 188 "autostart-manager.c"
}


GFile* autostart_manager_get_autostart_desktop_file (AutostartManager* self) {
	GFile* result = NULL;
	GFile* install_dir = NULL;
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_;
	GFile* desktop_file = NULL;
	GFile* _tmp18_;
	GFile* _tmp19_ = NULL;
	GFile* _tmp20_;
	gboolean _tmp21_;
	GFile* _tmp23_;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	g_return_val_if_fail (IS_AUTOSTART_MANAGER (self), NULL);
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp0_ = geary_application_get_instance ();
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp1_ = _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp2_ = geary_application_get_install_dir (_tmp1_);
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	install_dir = _tmp2_;
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp4_ = install_dir;
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	if (_tmp4_ != NULL) {
#line 220 "autostart-manager.c"
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp5_ = install_dir;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp6_ = g_file_get_child (_tmp5_, "share");
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp7_ = _tmp6_;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp8_ = g_file_get_child (_tmp7_, "applications");
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp9_ = _tmp8_;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp10_ = g_file_get_child (_tmp9_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp3_);
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp3_ = _tmp10_;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp9_);
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp7_);
#line 247 "autostart-manager.c"
	} else {
		GFile* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp11_ = g_file_new_for_path (GEARY_APPLICATION_SOURCE_ROOT_DIR);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp12_ = _tmp11_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp13_ = g_file_get_child (_tmp12_, "build");
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp14_ = _tmp13_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp15_ = g_file_get_child (_tmp14_, "desktop");
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp16_ = _tmp15_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp17_ = g_file_get_child (_tmp16_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp3_);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp3_ = _tmp17_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp16_);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp14_);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp12_);
#line 280 "autostart-manager.c"
	}
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp18_ = _g_object_ref0 (_tmp3_);
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	desktop_file = _tmp18_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp20_ = desktop_file;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp21_ = g_file_query_exists (_tmp20_, NULL);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	if (_tmp21_) {
#line 292 "autostart-manager.c"
		GFile* _tmp22_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp22_ = desktop_file;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp19_ = _tmp22_;
#line 298 "autostart-manager.c"
	} else {
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp19_ = NULL;
#line 302 "autostart-manager.c"
	}
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp23_ = _g_object_ref0 (_tmp19_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	result = _tmp23_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_object_unref0 (desktop_file);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_object_unref0 (_tmp3_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_object_unref0 (install_dir);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	return result;
#line 316 "autostart-manager.c"
}


/**
     * Deletes the desktop file from autostart directory.
     */
void autostart_manager_delete_startup_file (AutostartManager* self) {
	GFile* _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp0_ = self->priv->startup_file;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp1_ = g_file_query_exists (_tmp0_, NULL);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	if (_tmp1_) {
#line 335 "autostart-manager.c"
		{
			GFile* _tmp2_;
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_tmp2_ = self->priv->startup_file;
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			g_file_delete (_tmp2_, NULL, &_inner_error_);
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 344 "autostart-manager.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			err = _inner_error_;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_tmp3_ = err;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_tmp4_ = _tmp3_->message;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			g_message ("autostart-manager.vala:46: Failed to delete startup file: %s", _tmp4_);
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_g_error_free0 (err);
#line 366 "autostart-manager.c"
		}
		__finally0:
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			g_clear_error (&_inner_error_);
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			return;
#line 377 "autostart-manager.c"
		}
	}
}


/**
     * Creates .desktop file in autostart directory (usually '$HOME/.config/autostart/') if no one exists.
     */
void autostart_manager_create_startup_file (AutostartManager* self) {
	GFile* _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp0_ = self->priv->startup_file;
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp1_ = g_file_query_exists (_tmp0_, NULL);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	if (_tmp1_) {
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		return;
#line 400 "autostart-manager.c"
	}
	{
		GFile* autostart_dir = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gboolean _tmp5_;
		GFile* autostart = NULL;
		GFile* _tmp7_;
		GFile* _tmp8_;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp2_ = self->priv->startup_file;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp3_ = g_file_get_parent (_tmp2_);
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		autostart_dir = _tmp3_;
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp4_ = autostart_dir;
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		if (!_tmp5_) {
#line 423 "autostart-manager.c"
			GFile* _tmp6_;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_tmp6_ = autostart_dir;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			g_file_make_directory_with_parents (_tmp6_, NULL, &_inner_error_);
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
				_g_object_unref0 (autostart_dir);
#line 433 "autostart-manager.c"
				goto __catch1_g_error;
			}
		}
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp7_ = autostart_manager_get_autostart_desktop_file (self);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		autostart = _tmp7_;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp8_ = autostart;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		if (_tmp8_ == NULL) {
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			g_message ("autostart-manager.vala:64: Autostart file is not installed!");
#line 447 "autostart-manager.c"
		} else {
			GFile* _tmp9_;
			GFile* _tmp10_;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_tmp9_ = autostart;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			_tmp10_ = self->priv->startup_file;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			g_file_copy (_tmp9_, _tmp10_, 0, NULL, NULL, NULL, &_inner_error_);
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
				_g_object_unref0 (autostart);
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
				_g_object_unref0 (autostart_dir);
#line 463 "autostart-manager.c"
				goto __catch1_g_error;
			}
		}
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (autostart);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_object_unref0 (autostart_dir);
#line 471 "autostart-manager.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		err = _inner_error_;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_inner_error_ = NULL;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp11_ = err;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_tmp12_ = _tmp11_->message;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		g_message ("autostart-manager.vala:69: Failed to create startup file: %s", _tmp12_);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		_g_error_free0 (err);
#line 491 "autostart-manager.c"
	}
	__finally1:
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		g_clear_error (&_inner_error_);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		return;
#line 502 "autostart-manager.c"
	}
}


/**
     * Callback for startup notification option changes.
     */
void autostart_manager_on_startup_notification_change (AutostartManager* self) {
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	Configuration* _tmp2_;
	Configuration* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp0_ = geary_application_get_instance ();
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp1_ = _tmp0_;
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp2_ = geary_application_get_config (_tmp1_);
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp3_ = _tmp2_;
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp4_ = configuration_get_startup_notifications (_tmp3_);
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp5_ = _tmp4_;
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	if (_tmp5_) {
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		autostart_manager_create_startup_file (self);
#line 535 "autostart-manager.c"
	} else {
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
		autostart_manager_delete_startup_file (self);
#line 539 "autostart-manager.c"
	}
}


void autostart_manager_sync_with_config (AutostartManager* self) {
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	Configuration* _tmp2_;
	Configuration* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp0_ = geary_application_get_instance ();
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp1_ = _tmp0_;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp2_ = geary_application_get_config (_tmp1_);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp3_ = _tmp2_;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp4_ = self->priv->startup_file;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	configuration_set_startup_notifications (_tmp3_, _tmp5_);
#line 567 "autostart-manager.c"
}


static void autostart_manager_class_init (AutostartManagerClass * klass) {
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	autostart_manager_parent_class = g_type_class_peek_parent (klass);
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	g_type_class_add_private (klass, sizeof (AutostartManagerPrivate));
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = autostart_manager_finalize;
#line 578 "autostart-manager.c"
}


static void autostart_manager_instance_init (AutostartManager * self) {
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	self->priv = AUTOSTART_MANAGER_GET_PRIVATE (self);
#line 585 "autostart-manager.c"
}


static void autostart_manager_finalize (GObject * obj) {
	AutostartManager * self;
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AUTOSTART_MANAGER, AutostartManager);
#line 15 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	_g_object_unref0 (self->priv->startup_file);
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/application/autostart-manager.vala"
	G_OBJECT_CLASS (autostart_manager_parent_class)->finalize (obj);
#line 597 "autostart-manager.c"
}


GType autostart_manager_get_type (void) {
	static volatile gsize autostart_manager_type_id__volatile = 0;
	if (g_once_init_enter (&autostart_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AutostartManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) autostart_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AutostartManager), 0, (GInstanceInitFunc) autostart_manager_instance_init, NULL };
		GType autostart_manager_type_id;
		autostart_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "AutostartManager", &g_define_type_info, 0);
		g_once_init_leave (&autostart_manager_type_id__volatile, autostart_manager_type_id);
	}
	return autostart_manager_type_id__volatile;
}



