/* geary-config.c generated by valac 0.36.12, the Vala compiler
 * generated from geary-config.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <geary-engine.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
typedef struct _ConfigurationPrivate ConfigurationPrivate;

#define CONFIGURATION_TYPE_DESKTOP_ENVIRONMENT (configuration_desktop_environment_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DATE_TYPE_CLOCK_FORMAT (date_clock_format_get_type ())
typedef struct _ParamSpecConfiguration ParamSpecConfiguration;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Configuration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ConfigurationPrivate * priv;
};

struct _ConfigurationClass {
	GTypeClass parent_class;
	void (*finalize) (Configuration *self);
};

struct _ConfigurationPrivate {
	GSettings* _settings;
	GSettings* _gnome_interface;
};

typedef enum  {
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN = 0,
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY
} ConfigurationDesktopEnvironment;

typedef enum  {
	DATE_CLOCK_FORMAT_TWELVE_HOURS,
	DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	DATE_CLOCK_FORMAT_TOTAL
} DateClockFormat;

struct _ParamSpecConfiguration {
	GParamSpec parent_instance;
};


static gpointer configuration_parent_class = NULL;

gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_configuration (GValue* value, gpointer v_object);
void value_take_configuration (GValue* value, gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
#define CONFIGURATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONFIGURATION, ConfigurationPrivate))
enum  {
	CONFIGURATION_0_PROPERTY
};
GType configuration_desktop_environment_get_type (void) G_GNUC_CONST;
#define CONFIGURATION_ATTACHMENTS_DIR_KEY "attachments-directory"
#define CONFIGURATION_PRINT_DIR_KEY "print-directory"
#define CONFIGURATION_WINDOW_WIDTH_KEY "window-width"
#define CONFIGURATION_WINDOW_HEIGHT_KEY "window-height"
#define CONFIGURATION_WINDOW_MAXIMIZE_KEY "window-maximize"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_KEY "folder-list-pane-position"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY "folder-list-pane-position-horizontal"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_VERTICAL_KEY "folder-list-pane-position-vertical"
#define CONFIGURATION_FOLDER_LIST_PANE_HORIZONTAL_KEY "folder-list-pane-horizontal"
#define CONFIGURATION_MESSAGES_PANE_POSITION_KEY "messages-pane-position"
#define CONFIGURATION_AUTOSELECT_KEY "autoselect"
#define CONFIGURATION_DISPLAY_PREVIEW_KEY "display-preview"
#define CONFIGURATION_PLAY_SOUNDS_KEY "play-sounds"
#define CONFIGURATION_SHOW_NOTIFICATIONS_KEY "show-notifications"
#define CONFIGURATION_STARTUP_NOTIFICATIONS_KEY "startup-notifications"
#define CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY "ask-open-attachment"
#define CONFIGURATION_COMPOSE_AS_HTML_KEY "compose-as-html"
#define CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES "spell-check-visible-languages"
#define CONFIGURATION_SPELL_CHECK_LANGUAGES "spell-check-languages"
#define CONFIGURATION_SEARCH_STRATEGY_KEY "search-strategy"
#define CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY "conversation-viewer-zoom"
#define CONFIGURATION_CLOCK_FORMAT_KEY "clock-format"
void configuration_init (gboolean is_installed, const gchar* schema_dir);
Configuration* configuration_new (const gchar* schema_id);
Configuration* configuration_construct (GType object_type, const gchar* schema_id);
static void configuration_set_settings (Configuration* self, GSettings* value);
static void configuration_set_gnome_interface (Configuration* self, GSettings* value);
void migrate_old_app_config (GSettings* newSettings, const gchar* old_app_id);
GSettings* configuration_get_settings (Configuration* self);
#define MIGRATE_OLD_APP_ID "org.yorba.geary"
void configuration_bind (Configuration* self, const gchar* key, GObject* object, const gchar* property, GSettingsBindFlags flags);
static void configuration_set_boolean (Configuration* self, const gchar* name, gboolean value);
GearySearchQueryStrategy configuration_get_search_strategy (Configuration* self);
void configuration_set_search_strategy (Configuration* self, GearySearchQueryStrategy strategy);
GSettings* configuration_get_gnome_interface (Configuration* self);
ConfigurationDesktopEnvironment configuration_get_desktop_environment (Configuration* self);
gchar* configuration_get_attachments_dir (Configuration* self);
void configuration_set_attachments_dir (Configuration* self, const gchar* value);
gchar* configuration_get_print_dir (Configuration* self);
void configuration_set_print_dir (Configuration* self, const gchar* value);
gint configuration_get_window_width (Configuration* self);
gint configuration_get_window_height (Configuration* self);
gboolean configuration_get_window_maximize (Configuration* self);
gint configuration_get_folder_list_pane_position_old (Configuration* self);
gint configuration_get_folder_list_pane_position_horizontal (Configuration* self);
void configuration_set_folder_list_pane_position_horizontal (Configuration* self, gint value);
gint configuration_get_folder_list_pane_position_vertical (Configuration* self);
gboolean configuration_get_folder_list_pane_horizontal (Configuration* self);
gint configuration_get_messages_pane_position (Configuration* self);
void configuration_set_messages_pane_position (Configuration* self, gint value);
gboolean configuration_get_autoselect (Configuration* self);
gboolean configuration_get_display_preview (Configuration* self);
gchar** configuration_get_spell_check_languages (Configuration* self, int* result_length1);
void configuration_set_spell_check_languages (Configuration* self, gchar** value, int value_length1);
gchar** configuration_get_spell_check_visible_languages (Configuration* self, int* result_length1);
gchar** international_get_user_preferred_languages (int* result_length1);
void configuration_set_spell_check_visible_languages (Configuration* self, gchar** value, int value_length1);
gboolean configuration_get_play_sounds (Configuration* self);
gboolean configuration_get_show_notifications (Configuration* self);
gboolean configuration_get_startup_notifications (Configuration* self);
void configuration_set_startup_notifications (Configuration* self, gboolean value);
GType date_clock_format_get_type (void) G_GNUC_CONST;
DateClockFormat configuration_get_clock_format (Configuration* self);
gboolean configuration_get_ask_open_attachment (Configuration* self);
void configuration_set_ask_open_attachment (Configuration* self, gboolean value);
gboolean configuration_get_compose_as_html (Configuration* self);
void configuration_set_compose_as_html (Configuration* self, gboolean value);
gdouble configuration_get_conversation_viewer_zoom (Configuration* self);
void configuration_set_conversation_viewer_zoom (Configuration* self, gdouble value);
static void configuration_finalize (Configuration * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType configuration_desktop_environment_get_type (void) {
	static volatile gsize configuration_desktop_environment_type_id__volatile = 0;
	if (g_once_init_enter (&configuration_desktop_environment_type_id__volatile)) {
		static const GEnumValue values[] = {{CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN, "CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN", "unknown"}, {CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY, "CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY", "unity"}, {0, NULL, NULL}};
		GType configuration_desktop_environment_type_id;
		configuration_desktop_environment_type_id = g_enum_register_static ("ConfigurationDesktopEnvironment", values);
		g_once_init_leave (&configuration_desktop_environment_type_id__volatile, configuration_desktop_environment_type_id);
	}
	return configuration_desktop_environment_type_id__volatile;
}


void configuration_init (gboolean is_installed, const gchar* schema_dir) {
	gboolean _tmp0_;
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = is_installed;
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (!_tmp0_) {
#line 184 "geary-config.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 45 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp1_ = schema_dir;
#line 45 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_vala_assert (_tmp1_ != NULL, "schema_dir != null");
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp2_ = schema_dir;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		g_setenv ("GSETTINGS_SCHEMA_DIR", _tmp2_, TRUE);
#line 195 "geary-config.c"
	}
}


Configuration* configuration_construct (GType object_type, const gchar* schema_id) {
	Configuration* self = NULL;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
#line 177 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (schema_id != NULL, NULL);
#line 177 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	self = (Configuration*) g_type_create_instance (object_type);
#line 179 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = schema_id;
#line 179 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_new (_tmp0_);
#line 179 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_;
#line 179 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	configuration_set_settings (self, _tmp2_);
#line 179 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_object_unref0 (_tmp2_);
#line 180 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = g_settings_new ("org.gnome.desktop.interface");
#line 180 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp4_ = _tmp3_;
#line 180 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	configuration_set_gnome_interface (self, _tmp4_);
#line 180 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_object_unref0 (_tmp4_);
#line 182 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp5_ = self->priv->_settings;
#line 182 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	migrate_old_app_config (_tmp5_, MIGRATE_OLD_APP_ID);
#line 177 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return self;
#line 236 "geary-config.c"
}


Configuration* configuration_new (const gchar* schema_id) {
#line 177 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return configuration_construct (TYPE_CONFIGURATION, schema_id);
#line 243 "geary-config.c"
}


void configuration_bind (Configuration* self, const gchar* key, GObject* object, const gchar* property, GSettingsBindFlags flags) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	GObject* _tmp2_;
	const gchar* _tmp3_;
	GSettingsBindFlags _tmp4_;
#line 185 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 185 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (key != NULL);
#line 185 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (G_IS_OBJECT (object));
#line 185 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (property != NULL);
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = key;
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp2_ = object;
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = property;
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp4_ = flags;
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_bind (_tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_);
#line 273 "geary-config.c"
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
#line 37 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (self) {
#line 281 "geary-config.c"
		gchar* _tmp0_;
#line 38 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp0_;
#line 38 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 289 "geary-config.c"
	} else {
		gchar* _tmp1_;
#line 40 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp1_;
#line 40 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 298 "geary-config.c"
	}
}


static void configuration_set_boolean (Configuration* self, const gchar* name, gboolean value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 190 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 190 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (name != NULL);
#line 191 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 191 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = name;
#line 191 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp2_ = value;
#line 191 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = g_settings_set_boolean (_tmp0_, _tmp1_, _tmp2_);
#line 191 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (!_tmp3_) {
#line 322 "geary-config.c"
		const gchar* _tmp4_;
		gboolean _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 192 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp4_ = name;
#line 192 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp5_ = value;
#line 192 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp6_ = bool_to_string (_tmp5_);
#line 192 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp7_ = _tmp6_;
#line 192 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		g_message ("geary-config.vala:192: Unable to set configuration value %s = %s", _tmp4_, _tmp7_);
#line 192 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_g_free0 (_tmp7_);
#line 339 "geary-config.c"
	}
}


GearySearchQueryStrategy configuration_get_search_strategy (Configuration* self) {
	GearySearchQueryStrategy result = 0;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	static GQuark _tmp6_label0 = 0;
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	static GQuark _tmp6_label1 = 0;
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	static GQuark _tmp6_label2 = 0;
#line 195 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_SEARCH_STRATEGY_KEY);
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_;
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp4_ = _tmp3_;
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_free0 (_tmp2_);
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp5_ = _tmp4_;
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_free (_tmp5_);
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("exact")))) {
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		switch (0) {
#line 383 "geary-config.c"
			default:
			{
#line 198 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_EXACT;
#line 198 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				return result;
#line 390 "geary-config.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("aggressive")))) {
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		switch (0) {
#line 396 "geary-config.c"
			default:
			{
#line 201 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE;
#line 201 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				return result;
#line 403 "geary-config.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("horizon")))) {
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		switch (0) {
#line 409 "geary-config.c"
			default:
			{
#line 204 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_HORIZON;
#line 204 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				return result;
#line 416 "geary-config.c"
			}
		}
	} else {
#line 196 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		switch (0) {
#line 422 "geary-config.c"
			default:
			{
#line 208 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE;
#line 208 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
				return result;
#line 429 "geary-config.c"
			}
		}
	}
}


void configuration_set_search_strategy (Configuration* self, GearySearchQueryStrategy strategy) {
	GearySearchQueryStrategy _tmp0_;
#line 212 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 213 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = strategy;
#line 213 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	switch (_tmp0_) {
#line 213 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_EXACT:
#line 446 "geary-config.c"
		{
			GSettings* _tmp1_;
#line 215 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			_tmp1_ = self->priv->_settings;
#line 215 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			g_settings_set_string (_tmp1_, CONFIGURATION_SEARCH_STRATEGY_KEY, "exact");
#line 216 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			break;
#line 455 "geary-config.c"
		}
#line 213 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE:
#line 459 "geary-config.c"
		{
			GSettings* _tmp2_;
#line 219 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			_tmp2_ = self->priv->_settings;
#line 219 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			g_settings_set_string (_tmp2_, CONFIGURATION_SEARCH_STRATEGY_KEY, "aggressive");
#line 220 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			break;
#line 468 "geary-config.c"
		}
#line 213 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_HORIZON:
#line 472 "geary-config.c"
		{
			GSettings* _tmp3_;
#line 223 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			_tmp3_ = self->priv->_settings;
#line 223 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			g_settings_set_string (_tmp3_, CONFIGURATION_SEARCH_STRATEGY_KEY, "horizon");
#line 224 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			break;
#line 481 "geary-config.c"
		}
		default:
#line 213 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE:
#line 486 "geary-config.c"
		{
			GSettings* _tmp4_;
#line 228 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			_tmp4_ = self->priv->_settings;
#line 228 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			g_settings_set_string (_tmp4_, CONFIGURATION_SEARCH_STRATEGY_KEY, "conservative");
#line 229 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			break;
#line 495 "geary-config.c"
		}
	}
}


GSettings* configuration_get_settings (Configuration* self) {
	GSettings* result;
	GSettings* _tmp0_;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 512 "geary-config.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return self ? g_object_ref (self) : NULL;
#line 519 "geary-config.c"
}


static void configuration_set_settings (Configuration* self, GSettings* value) {
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = value;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_settings);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	self->priv->_settings = _tmp1_;
#line 536 "geary-config.c"
}


GSettings* configuration_get_gnome_interface (Configuration* self) {
	GSettings* result;
	GSettings* _tmp0_;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_gnome_interface;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp0_;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 551 "geary-config.c"
}


static void configuration_set_gnome_interface (Configuration* self, GSettings* value) {
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = value;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_gnome_interface);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	self->priv->_gnome_interface = _tmp1_;
#line 568 "geary-config.c"
}


ConfigurationDesktopEnvironment configuration_get_desktop_environment (Configuration* self) {
	ConfigurationDesktopEnvironment result;
	gchar* xdg_current_desktop = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	xdg_current_desktop = _tmp1_;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = xdg_current_desktop;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (_tmp3_ != NULL) {
#line 591 "geary-config.c"
		const gchar* _tmp4_;
		gboolean _tmp5_;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp4_ = xdg_current_desktop;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp5_ = g_str_has_prefix (_tmp4_, "Unity");
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp2_ = _tmp5_;
#line 600 "geary-config.c"
	} else {
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp2_ = FALSE;
#line 604 "geary-config.c"
	}
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (_tmp2_) {
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		result = CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY;
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_g_free0 (xdg_current_desktop);
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		return result;
#line 614 "geary-config.c"
	} else {
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		result = CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_g_free0 (xdg_current_desktop);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		return result;
#line 622 "geary-config.c"
	}
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_free0 (xdg_current_desktop);
#line 626 "geary-config.c"
}


gchar* configuration_get_attachments_dir (Configuration* self) {
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_ATTACHMENTS_DIR_KEY);
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 644 "geary-config.c"
}


void configuration_set_attachments_dir (Configuration* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_set_string (_tmp0_, CONFIGURATION_ATTACHMENTS_DIR_KEY, _tmp1_);
#line 659 "geary-config.c"
}


gchar* configuration_get_print_dir (Configuration* self) {
	gchar* result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_PRINT_DIR_KEY);
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 677 "geary-config.c"
}


void configuration_set_print_dir (Configuration* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_set_string (_tmp0_, CONFIGURATION_PRINT_DIR_KEY, _tmp1_);
#line 692 "geary-config.c"
}


gint configuration_get_window_width (Configuration* self) {
	gint result;
	GSettings* _tmp0_;
	gint _tmp1_;
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_int (_tmp0_, CONFIGURATION_WINDOW_WIDTH_KEY);
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 710 "geary-config.c"
}


gint configuration_get_window_height (Configuration* self) {
	gint result;
	GSettings* _tmp0_;
	gint _tmp1_;
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_int (_tmp0_, CONFIGURATION_WINDOW_HEIGHT_KEY);
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 728 "geary-config.c"
}


gboolean configuration_get_window_maximize (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_WINDOW_MAXIMIZE_KEY);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 746 "geary-config.c"
}


gint configuration_get_folder_list_pane_position_old (Configuration* self) {
	gint result;
	GSettings* _tmp0_;
	gint _tmp1_;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_KEY);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 764 "geary-config.c"
}


gint configuration_get_folder_list_pane_position_horizontal (Configuration* self) {
	gint result;
	GSettings* _tmp0_;
	gint _tmp1_;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY);
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 782 "geary-config.c"
}


void configuration_set_folder_list_pane_position_horizontal (Configuration* self, gint value) {
	GSettings* _tmp0_;
	gint _tmp1_;
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_set_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY, _tmp1_);
#line 797 "geary-config.c"
}


gint configuration_get_folder_list_pane_position_vertical (Configuration* self) {
	gint result;
	GSettings* _tmp0_;
	gint _tmp1_;
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_VERTICAL_KEY);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 815 "geary-config.c"
}


gboolean configuration_get_folder_list_pane_horizontal (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_HORIZONTAL_KEY);
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 833 "geary-config.c"
}


gint configuration_get_messages_pane_position (Configuration* self) {
	gint result;
	GSettings* _tmp0_;
	gint _tmp1_;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_int (_tmp0_, CONFIGURATION_MESSAGES_PANE_POSITION_KEY);
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 851 "geary-config.c"
}


void configuration_set_messages_pane_position (Configuration* self, gint value) {
	GSettings* _tmp0_;
	gint _tmp1_;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_set_int (_tmp0_, CONFIGURATION_MESSAGES_PANE_POSITION_KEY, _tmp1_);
#line 866 "geary-config.c"
}


gboolean configuration_get_autoselect (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_AUTOSELECT_KEY);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 884 "geary-config.c"
}


gboolean configuration_get_display_preview (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_DISPLAY_PREVIEW_KEY);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 902 "geary-config.c"
}


gchar** configuration_get_spell_check_languages (Configuration* self, int* result_length1) {
	gchar** result;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_LANGUAGES);
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = _tmp2_;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (result_length1) {
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		*result_length1 = _tmp3__length1;
#line 927 "geary-config.c"
	}
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp3_;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 933 "geary-config.c"
}


void configuration_set_spell_check_languages (Configuration* self, gchar** value, int value_length1) {
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1__length1 = value_length1;
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_set_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_LANGUAGES, _tmp1_);
#line 951 "geary-config.c"
}


gchar** configuration_get_spell_check_visible_languages (Configuration* self, int* result_length1) {
	gchar** result;
	gchar** langs = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint langs_length1;
	gint _langs_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES);
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	langs = _tmp2_;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	langs_length1 = _vala_array_length (_tmp1_);
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_langs_size_ = langs_length1;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = langs;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3__length1 = langs_length1;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (_tmp3__length1 == 0) {
#line 985 "geary-config.c"
		gint _tmp4_;
		gchar** _tmp5_;
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_tmp5_ = international_get_user_preferred_languages (&_tmp4_);
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		langs = (_vala_array_free (langs, langs_length1, (GDestroyNotify) g_free), NULL);
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		langs = _tmp5_;
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		langs_length1 = _tmp4_;
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		_langs_size_ = langs_length1;
#line 998 "geary-config.c"
	}
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp6_ = langs;
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp6__length1 = langs_length1;
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (result_length1) {
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		*result_length1 = _tmp6__length1;
#line 1008 "geary-config.c"
	}
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp6_;
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 1014 "geary-config.c"
}


void configuration_set_spell_check_visible_languages (Configuration* self, gchar** value, int value_length1) {
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1__length1 = value_length1;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_set_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES, _tmp1_);
#line 1032 "geary-config.c"
}


gboolean configuration_get_play_sounds (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_PLAY_SOUNDS_KEY);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 1050 "geary-config.c"
}


gboolean configuration_get_show_notifications (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 142 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 142 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 142 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_SHOW_NOTIFICATIONS_KEY);
#line 142 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 142 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 1068 "geary-config.c"
}


gboolean configuration_get_startup_notifications (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 146 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 146 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 146 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_STARTUP_NOTIFICATIONS_KEY);
#line 146 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 146 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 1086 "geary-config.c"
}


void configuration_set_startup_notifications (Configuration* self, gboolean value) {
	gboolean _tmp0_;
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = value;
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	configuration_set_boolean (self, CONFIGURATION_STARTUP_NOTIFICATIONS_KEY, _tmp0_);
#line 1098 "geary-config.c"
}


DateClockFormat configuration_get_clock_format (Configuration* self) {
	DateClockFormat result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 152 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 153 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_gnome_interface;
#line 153 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_CLOCK_FORMAT_KEY);
#line 153 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_;
#line 153 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp3_ = g_strcmp0 (_tmp2_, "12h") == 0;
#line 153 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_free0 (_tmp2_);
#line 153 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (_tmp3_) {
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		result = DATE_CLOCK_FORMAT_TWELVE_HOURS;
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		return result;
#line 1126 "geary-config.c"
	} else {
#line 156 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		result = DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS;
#line 156 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		return result;
#line 1132 "geary-config.c"
	}
}


gboolean configuration_get_ask_open_attachment (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 161 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 161 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 161 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY);
#line 161 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 161 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 1151 "geary-config.c"
}


void configuration_set_ask_open_attachment (Configuration* self, gboolean value) {
	gboolean _tmp0_;
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = value;
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	configuration_set_boolean (self, CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY, _tmp0_);
#line 1163 "geary-config.c"
}


gboolean configuration_get_compose_as_html (Configuration* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 166 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 166 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 166 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, CONFIGURATION_COMPOSE_AS_HTML_KEY);
#line 166 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 166 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 1181 "geary-config.c"
}


void configuration_set_compose_as_html (Configuration* self, gboolean value) {
	gboolean _tmp0_;
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = value;
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	configuration_set_boolean (self, CONFIGURATION_COMPOSE_AS_HTML_KEY, _tmp0_);
#line 1193 "geary-config.c"
}


gdouble configuration_get_conversation_viewer_zoom (Configuration* self) {
	gdouble result;
	GSettings* _tmp0_;
	gdouble _tmp1_;
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0.0);
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_double (_tmp0_, CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY);
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	result = _tmp1_;
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return result;
#line 1211 "geary-config.c"
}


void configuration_set_conversation_viewer_zoom (Configuration* self, gdouble value) {
	GSettings* _tmp0_;
	gdouble _tmp1_;
#line 172 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 172 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 172 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 172 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_settings_set_double (_tmp0_, CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY, _tmp1_);
#line 1226 "geary-config.c"
}


static void value_configuration_init (GValue* value) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	value->data[0].v_pointer = NULL;
#line 1233 "geary-config.c"
}


static void value_configuration_free_value (GValue* value) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (value->data[0].v_pointer) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		configuration_unref (value->data[0].v_pointer);
#line 1242 "geary-config.c"
	}
}


static void value_configuration_copy_value (const GValue* src_value, GValue* dest_value) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (src_value->data[0].v_pointer) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		dest_value->data[0].v_pointer = configuration_ref (src_value->data[0].v_pointer);
#line 1252 "geary-config.c"
	} else {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1256 "geary-config.c"
	}
}


static gpointer value_configuration_peek_pointer (const GValue* value) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return value->data[0].v_pointer;
#line 1264 "geary-config.c"
}


static gchar* value_configuration_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (collect_values[0].v_pointer) {
#line 1271 "geary-config.c"
		Configuration * object;
		object = collect_values[0].v_pointer;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		if (object->parent_instance.g_class == NULL) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1278 "geary-config.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1282 "geary-config.c"
		}
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		value->data[0].v_pointer = configuration_ref (object);
#line 1286 "geary-config.c"
	} else {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		value->data[0].v_pointer = NULL;
#line 1290 "geary-config.c"
	}
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return NULL;
#line 1294 "geary-config.c"
}


static gchar* value_configuration_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Configuration ** object_p;
	object_p = collect_values[0].v_pointer;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (!object_p) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1305 "geary-config.c"
	}
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (!value->data[0].v_pointer) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		*object_p = NULL;
#line 1311 "geary-config.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		*object_p = value->data[0].v_pointer;
#line 1315 "geary-config.c"
	} else {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		*object_p = configuration_ref (value->data[0].v_pointer);
#line 1319 "geary-config.c"
	}
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return NULL;
#line 1323 "geary-config.c"
}


GParamSpec* param_spec_configuration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecConfiguration* spec;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CONFIGURATION), NULL);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return G_PARAM_SPEC (spec);
#line 1337 "geary-config.c"
}


gpointer value_get_configuration (const GValue* value) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION), NULL);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return value->data[0].v_pointer;
#line 1346 "geary-config.c"
}


void value_set_configuration (GValue* value, gpointer v_object) {
	Configuration * old;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION));
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	old = value->data[0].v_pointer;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (v_object) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIGURATION));
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		value->data[0].v_pointer = v_object;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		configuration_ref (value->data[0].v_pointer);
#line 1366 "geary-config.c"
	} else {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		value->data[0].v_pointer = NULL;
#line 1370 "geary-config.c"
	}
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (old) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		configuration_unref (old);
#line 1376 "geary-config.c"
	}
}


void value_take_configuration (GValue* value, gpointer v_object) {
	Configuration * old;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION));
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	old = value->data[0].v_pointer;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (v_object) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIGURATION));
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		value->data[0].v_pointer = v_object;
#line 1395 "geary-config.c"
	} else {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		value->data[0].v_pointer = NULL;
#line 1399 "geary-config.c"
	}
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (old) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		configuration_unref (old);
#line 1405 "geary-config.c"
	}
}


static void configuration_class_init (ConfigurationClass * klass) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	configuration_parent_class = g_type_class_peek_parent (klass);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	((ConfigurationClass *) klass)->finalize = configuration_finalize;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_type_class_add_private (klass, sizeof (ConfigurationPrivate));
#line 1417 "geary-config.c"
}


static void configuration_instance_init (Configuration * self) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	self->priv = CONFIGURATION_GET_PRIVATE (self);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	self->ref_count = 1;
#line 1426 "geary-config.c"
}


static void configuration_finalize (Configuration * obj) {
	Configuration * self;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONFIGURATION, Configuration);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_signal_handlers_destroy (self);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_settings);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_gnome_interface);
#line 1440 "geary-config.c"
}


/**
 * Provides convenience properties to current Geary GSettings values.
 */
GType configuration_get_type (void) {
	static volatile gsize configuration_type_id__volatile = 0;
	if (g_once_init_enter (&configuration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_configuration_init, value_configuration_free_value, value_configuration_copy_value, value_configuration_peek_pointer, "p", value_configuration_collect_value, "p", value_configuration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ConfigurationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) configuration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Configuration), 0, (GInstanceInitFunc) configuration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType configuration_type_id;
		configuration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Configuration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&configuration_type_id__volatile, configuration_type_id);
	}
	return configuration_type_id__volatile;
}


gpointer configuration_ref (gpointer instance) {
	Configuration * self;
	self = instance;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	g_atomic_int_inc (&self->ref_count);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	return instance;
#line 1468 "geary-config.c"
}


void configuration_unref (gpointer instance) {
	Configuration * self;
	self = instance;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		CONFIGURATION_GET_CLASS (self)->finalize (self);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/application/geary-config.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1481 "geary-config.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



