/* contact-list-store.c generated by valac 0.36.12, the Vala compiler
 * generated from contact-list-store.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <geary-engine.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>


#define TYPE_CONTACT_LIST_STORE (contact_list_store_get_type ())
#define CONTACT_LIST_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTACT_LIST_STORE, ContactListStore))
#define CONTACT_LIST_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTACT_LIST_STORE, ContactListStoreClass))
#define IS_CONTACT_LIST_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTACT_LIST_STORE))
#define IS_CONTACT_LIST_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTACT_LIST_STORE))
#define CONTACT_LIST_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTACT_LIST_STORE, ContactListStoreClass))

typedef struct _ContactListStore ContactListStore;
typedef struct _ContactListStoreClass ContactListStoreClass;
typedef struct _ContactListStorePrivate ContactListStorePrivate;

#define CONTACT_LIST_STORE_TYPE_COLUMN (contact_list_store_column_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ContactListStoreLoadData ContactListStoreLoadData;
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))

struct _ContactListStore {
	GtkListStore parent_instance;
	ContactListStorePrivate * priv;
};

struct _ContactListStoreClass {
	GtkListStoreClass parent_class;
};

struct _ContactListStorePrivate {
	guint LOAD_BATCH_SIZE;
	GearyContactStore* _contact_store;
};

typedef enum  {
	CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT,
	CONTACT_LIST_STORE_COLUMN_CONTACT_MARKUP_NAME,
	CONTACT_LIST_STORE_COLUMN_PRIOR_KEYS
} ContactListStoreColumn;

struct _ContactListStoreLoadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	ContactListStore* self;
	guint count;
	GeeIterator* _contact_it;
	GearyContactStore* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	GeeIterator* _tmp6_;
	gboolean _tmp7_;
	GearyContact* contact;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	GearyContact* _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
};


static gpointer contact_list_store_parent_class = NULL;
static GearyBaseInterfaceIface * contact_list_store_geary_base_interface_parent_iface = NULL;

GType contact_list_store_get_type (void) G_GNUC_CONST;
#define CONTACT_LIST_STORE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONTACT_LIST_STORE, ContactListStorePrivate))
enum  {
	CONTACT_LIST_STORE_0_PROPERTY,
	CONTACT_LIST_STORE_CONTACT_STORE_PROPERTY
};
GearyContactStore* contact_list_store_get_contact_store (ContactListStore* self);
static void contact_list_store_on_contact_added (ContactListStore* self, GearyContact* contact);
static void _contact_list_store_on_contact_added_geary_contact_store_contact_added (GearyContactStore* _sender, GearyContact* contact, gpointer self);
static void contact_list_store_on_contact_updated (ContactListStore* self, GearyContact* contact);
static void _contact_list_store_on_contact_updated_geary_contact_store_contact_updated (GearyContactStore* _sender, GearyContact* contact, gpointer self);
GType* contact_list_store_column_get_types (int* result_length1);
GType contact_list_store_column_get_type (void) G_GNUC_CONST;
#define CONTACT_LIST_STORE_CONTACT_VISIBILITY_THRESHOLD GEARY_CONTACT_IMPORTANCE_TO_TO
static gint contact_list_store_sort_func (GtkTreeModel* model, GtkTreeIter* aiter, GtkTreeIter* biter);
ContactListStore* contact_list_store_new (GearyContactStore* contact_store);
ContactListStore* contact_list_store_construct (GType object_type, GearyContactStore* contact_store);
static void contact_list_store_set_contact_store (ContactListStore* self, GearyContactStore* value);
static void contact_list_store_load_data_free (gpointer _data);
static void contact_list_store_load_async_ready_wrapper (GObject *source_object, GAsyncResult *res, void *user_data);
void contact_list_store_load (ContactListStore* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void contact_list_store_load_finish (ContactListStore* self, GAsyncResult* _res_);
static gboolean contact_list_store_load_co (ContactListStoreLoadData* _data_);
static inline void contact_list_store_add_contact (ContactListStore* self, GearyContact* contact);
static gboolean _contact_list_store_load_co_gsource_func (gpointer self);
static gint _contact_list_store_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self);
GearyContact* contact_list_store_get_contact (ContactListStore* self, GtkTreeIter* iter);
gchar* contact_list_store_get_rfc822_string (ContactListStore* self, GtkTreeIter* iter);
void contact_list_store_set_highlighted_result (ContactListStore* self, GtkTreeIter* iter, const gchar* highlighted_result, const gchar* current_address_key);
static void contact_list_store_update_contact (ContactListStore* self, GearyContact* updated_contact);
static void contact_list_store_finalize (GObject * obj);
static void _vala_contact_list_store_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_contact_list_store_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _contact_list_store_on_contact_added_geary_contact_store_contact_added (GearyContactStore* _sender, GearyContact* contact, gpointer self) {
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_on_contact_added ((ContactListStore*) self, contact);
#line 127 "contact-list-store.c"
}


static void _contact_list_store_on_contact_updated_geary_contact_store_contact_updated (GearyContactStore* _sender, GearyContact* contact, gpointer self) {
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_on_contact_updated ((ContactListStore*) self, contact);
#line 134 "contact-list-store.c"
}


GType* contact_list_store_column_get_types (int* result_length1) {
	GType* result = NULL;
	GType* _tmp0_;
	GType* _tmp1_;
	gint _tmp1__length1;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = g_new0 (GType, 3);
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_[0] = GEARY_TYPE_CONTACT;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_[1] = G_TYPE_STRING;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_[2] = GEE_TYPE_HASH_SET;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp1_ = _tmp0_;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp1__length1 = 3;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (result_length1) {
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		*result_length1 = _tmp1__length1;
#line 159 "contact-list-store.c"
	}
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	result = _tmp1_;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return result;
#line 165 "contact-list-store.c"
}


GType contact_list_store_column_get_type (void) {
	static volatile gsize contact_list_store_column_type_id__volatile = 0;
	if (g_once_init_enter (&contact_list_store_column_type_id__volatile)) {
		static const GEnumValue values[] = {{CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT, "CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT", "contact-object"}, {CONTACT_LIST_STORE_COLUMN_CONTACT_MARKUP_NAME, "CONTACT_LIST_STORE_COLUMN_CONTACT_MARKUP_NAME", "contact-markup-name"}, {CONTACT_LIST_STORE_COLUMN_PRIOR_KEYS, "CONTACT_LIST_STORE_COLUMN_PRIOR_KEYS", "prior-keys"}, {0, NULL, NULL}};
		GType contact_list_store_column_type_id;
		contact_list_store_column_type_id = g_enum_register_static ("ContactListStoreColumn", values);
		g_once_init_leave (&contact_list_store_column_type_id__volatile, contact_list_store_column_type_id);
	}
	return contact_list_store_column_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return self ? g_object_ref (self) : NULL;
#line 184 "contact-list-store.c"
}


static gint contact_list_store_sort_func (GtkTreeModel* model, GtkTreeIter* aiter, GtkTreeIter* biter) {
	gint result = 0;
	GValue avalue = {0};
	GValue bvalue = {0};
	GtkTreeModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	GValue _tmp5_ = {0};
	GearyContact* acontact = NULL;
	GObject* _tmp6_;
	GearyContact* _tmp7_;
	GearyContact* bcontact = NULL;
	GObject* _tmp8_;
	GearyContact* _tmp9_;
	GearyContact* _tmp10_;
	GearyContact* _tmp11_;
	gboolean _tmp12_ = FALSE;
	GearyContact* _tmp13_;
	gboolean _tmp15_ = FALSE;
	GearyContact* _tmp16_;
	GearyContact* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GearyContact* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GearyContact* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	GearyContact* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gchar* _tmp30_ = NULL;
	GearyContact* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	gchar* anormalized_real_name = NULL;
	gchar* _tmp40_;
	gchar* _tmp41_ = NULL;
	GearyContact* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gchar* bnormalized_real_name = NULL;
	gchar* _tmp51_;
	gint _result_ = 0;
	GCompareFunc _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	GCompareFunc _tmp57_;
	GearyContact* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	GearyContact* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	gint _tmp64_;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (GTK_IS_TREE_MODEL (model), 0);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (aiter != NULL, 0);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (biter != NULL, 0);
#line 19 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = model;
#line 19 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp1_ = *aiter;
#line 19 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	gtk_tree_model_get_value (_tmp0_, &_tmp1_, (gint) CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT, &_tmp2_);
#line 19 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 19 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	avalue = _tmp2_;
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp3_ = model;
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp4_ = *biter;
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	gtk_tree_model_get_value (_tmp3_, &_tmp4_, (gint) CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT, &_tmp5_);
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	bvalue = _tmp5_;
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp6_ = g_value_get_object (&avalue);
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GEARY_TYPE_CONTACT) ? ((GearyContact*) _tmp6_) : NULL);
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	acontact = _tmp7_;
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp8_ = g_value_get_object (&bvalue);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, GEARY_TYPE_CONTACT) ? ((GearyContact*) _tmp8_) : NULL);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	bcontact = _tmp9_;
#line 26 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp10_ = acontact;
#line 26 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp11_ = bcontact;
#line 26 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp10_ == _tmp11_) {
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		result = 0;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (bcontact);
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (acontact);
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		return result;
#line 304 "contact-list-store.c"
	}
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp13_ = acontact;
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp13_ == NULL) {
#line 310 "contact-list-store.c"
		GearyContact* _tmp14_;
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp14_ = bcontact;
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp12_ = _tmp14_ != NULL;
#line 316 "contact-list-store.c"
	} else {
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp12_ = FALSE;
#line 320 "contact-list-store.c"
	}
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp12_) {
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		result = -1;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (bcontact);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (acontact);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		return result;
#line 336 "contact-list-store.c"
	}
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp16_ = acontact;
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp16_ != NULL) {
#line 342 "contact-list-store.c"
		GearyContact* _tmp17_;
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp17_ = bcontact;
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp15_ = _tmp17_ == NULL;
#line 348 "contact-list-store.c"
	} else {
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp15_ = FALSE;
#line 352 "contact-list-store.c"
	}
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp15_) {
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		result = 1;
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (bcontact);
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (acontact);
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		return result;
#line 368 "contact-list-store.c"
	}
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp18_ = acontact;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp19_ = geary_contact_get_highest_importance (_tmp18_);
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp20_ = _tmp19_;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp21_ = bcontact;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp22_ = geary_contact_get_highest_importance (_tmp21_);
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp23_ = _tmp22_;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp20_ > _tmp23_) {
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		result = -1;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (bcontact);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (acontact);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		return result;
#line 396 "contact-list-store.c"
	}
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp24_ = acontact;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp25_ = geary_contact_get_highest_importance (_tmp24_);
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp26_ = _tmp25_;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp27_ = bcontact;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp28_ = geary_contact_get_highest_importance (_tmp27_);
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp29_ = _tmp28_;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp26_ < _tmp29_) {
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		result = 1;
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (bcontact);
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (acontact);
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		return result;
#line 424 "contact-list-store.c"
	}
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp31_ = acontact;
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp32_ = geary_contact_get_real_name (_tmp31_);
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp33_ = _tmp32_;
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp33_ == NULL) {
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp30_);
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp30_ = NULL;
#line 438 "contact-list-store.c"
	} else {
		GearyContact* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp34_ = acontact;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp35_ = geary_contact_get_real_name (_tmp34_);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp36_ = _tmp35_;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp37_ = g_utf8_normalize (_tmp36_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp38_ = _tmp37_;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp39_ = g_utf8_casefold (_tmp38_, (gssize) -1);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp30_);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp30_ = _tmp39_;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp38_);
#line 464 "contact-list-store.c"
	}
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp40_ = g_strdup (_tmp30_);
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	anormalized_real_name = _tmp40_;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp42_ = bcontact;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp43_ = geary_contact_get_real_name (_tmp42_);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp44_ = _tmp43_;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp44_ == NULL) {
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp41_);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp41_ = NULL;
#line 482 "contact-list-store.c"
	} else {
		GearyContact* _tmp45_;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp45_ = bcontact;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp46_ = geary_contact_get_real_name (_tmp45_);
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp47_ = _tmp46_;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp48_ = g_utf8_normalize (_tmp47_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp49_ = _tmp48_;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp50_ = g_utf8_casefold (_tmp49_, (gssize) -1);
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp41_);
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp41_ = _tmp50_;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp49_);
#line 508 "contact-list-store.c"
	}
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp51_ = g_strdup (_tmp41_);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	bnormalized_real_name = _tmp51_;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp52_ = g_strcmp0;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp53_ = anormalized_real_name;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp54_ = bnormalized_real_name;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp55_ = _tmp52_ (_tmp53_, _tmp54_);
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_result_ = _tmp55_;
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp56_ = _result_;
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp56_ != 0) {
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		result = _result_;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (bnormalized_real_name);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp41_);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (anormalized_real_name);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp30_);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (bcontact);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (acontact);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		return result;
#line 548 "contact-list-store.c"
	}
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp57_ = g_strcmp0;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp58_ = acontact;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp59_ = geary_contact_get_normalized_email (_tmp58_);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp60_ = _tmp59_;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp61_ = bcontact;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp62_ = geary_contact_get_normalized_email (_tmp61_);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp63_ = _tmp62_;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp64_ = _tmp57_ (_tmp60_, _tmp63_);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	result = _tmp64_;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_free0 (bnormalized_real_name);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_free0 (_tmp41_);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_free0 (anormalized_real_name);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_free0 (_tmp30_);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_object_unref0 (bcontact);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_object_unref0 (acontact);
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&bvalue) ? (g_value_unset (&bvalue), NULL) : NULL;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&avalue) ? (g_value_unset (&avalue), NULL) : NULL;
#line 51 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return result;
#line 586 "contact-list-store.c"
}


ContactListStore* contact_list_store_construct (GType object_type, GearyContactStore* contact_store) {
	ContactListStore * self = NULL;
	gint _tmp0_;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
	GearyContactStore* _tmp3_;
	GearyContactStore* _tmp4_;
	GearyContactStore* _tmp5_;
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (GEARY_IS_CONTACT_STORE (contact_store), NULL);
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	self = (ContactListStore*) g_object_new (object_type, NULL);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp1_ = contact_list_store_column_get_types (&_tmp0_);
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2_ = _tmp1_;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2__length1 = _tmp0_;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	gtk_list_store_set_column_types (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_store_get_type (), GtkListStore), _tmp0_, _tmp2_);
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp3_ = contact_store;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_set_contact_store (self, _tmp3_);
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp4_ = contact_store;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_signal_connect_object (_tmp4_, "contact-added", (GCallback) _contact_list_store_on_contact_added_geary_contact_store_contact_added, self, 0);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp5_ = contact_store;
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_signal_connect_object (_tmp5_, "contact-updated", (GCallback) _contact_list_store_on_contact_updated_geary_contact_store_contact_updated, self, 0);
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return self;
#line 629 "contact-list-store.c"
}


ContactListStore* contact_list_store_new (GearyContactStore* contact_store) {
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return contact_list_store_construct (TYPE_CONTACT_LIST_STORE, contact_store);
#line 636 "contact-list-store.c"
}


static void contact_list_store_load_data_free (gpointer _data) {
	ContactListStoreLoadData* _data_;
	_data_ = _data;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_object_unref0 (_data_->self);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_slice_free (ContactListStoreLoadData, _data_);
#line 647 "contact-list-store.c"
}


static void contact_list_store_load_async_ready_wrapper (GObject *source_object, GAsyncResult *res, void *user_data) {
	ContactListStoreLoadData* _task_data_;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_task_data_->_callback_ != NULL) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 659 "contact-list-store.c"
	}
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_task_data_->_task_complete_ = TRUE;
#line 663 "contact-list-store.c"
}


void contact_list_store_load (ContactListStore* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	ContactListStoreLoadData* _data_;
	ContactListStore* _tmp0_;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_data_ = g_slice_new0 (ContactListStoreLoadData);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_data_->_callback_ = _callback_;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, contact_list_store_load_async_ready_wrapper, _user_data_);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_callback_ == NULL) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_task_complete_ = TRUE;
#line 680 "contact-list-store.c"
	}
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contact_list_store_load_data_free);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_data_->self = _tmp0_;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_load_co (_data_);
#line 690 "contact-list-store.c"
}


void contact_list_store_load_finish (ContactListStore* self, GAsyncResult* _res_) {
	ContactListStoreLoadData* _data_;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 698 "contact-list-store.c"
}


/**
     * Loads contacts from the model's contact store.
     */
static gboolean _contact_list_store_load_co_gsource_func (gpointer self) {
	gboolean result;
	result = contact_list_store_load_co (self);
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return result;
#line 710 "contact-list-store.c"
}


static gint _contact_list_store_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self) {
	gint result;
	result = contact_list_store_sort_func (model, a, b);
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return result;
#line 719 "contact-list-store.c"
}


static gboolean contact_list_store_load_co (ContactListStoreLoadData* _data_) {
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	switch (_data_->_state_) {
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		case 0:
#line 728 "contact-list-store.c"
		goto _state_0;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		case 1:
#line 732 "contact-list-store.c"
		goto _state_1;
		default:
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		g_assert_not_reached ();
#line 737 "contact-list-store.c"
	}
	_state_0:
#line 89 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_data_->count = (guint) 0;
#line 742 "contact-list-store.c"
	{
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_tmp0_ = _data_->self->priv->_contact_store;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_tmp1_ = geary_contact_store_get_contacts (_data_->_tmp0_);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (_data_->_tmp3_);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_data_->_contact_it = _data_->_tmp5_;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		while (TRUE) {
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp6_ = _data_->_contact_it;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp7_ = gee_iterator_next (_data_->_tmp6_);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			if (!_data_->_tmp7_) {
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				break;
#line 770 "contact-list-store.c"
			}
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp8_ = _data_->_contact_it;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->contact = (GearyContact*) _data_->_tmp9_;
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp10_ = _data_->contact;
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			contact_list_store_add_contact (_data_->self, _data_->_tmp10_);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp11_ = _data_->count;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->count = _data_->_tmp11_ + 1;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp12_ = _data_->count;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_data_->_tmp13_ = _data_->self->priv->LOAD_BATCH_SIZE;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			if ((_data_->_tmp12_ % _data_->_tmp13_) == ((guint) 0)) {
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _contact_list_store_load_co_gsource_func, _data_, NULL);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				_data_->_state_ = 1;
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				return FALSE;
#line 798 "contact-list-store.c"
				_state_1:
				;
			}
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_g_object_unref0 (_data_->contact);
#line 804 "contact-list-store.c"
		}
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (_data_->_contact_it);
#line 808 "contact-list-store.c"
	}
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	gtk_tree_sortable_set_sort_func (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GTK_TYPE_TREE_SORTABLE, GtkTreeSortable), (gint) CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT, _contact_list_store_sort_func_gtk_tree_iter_compare_func, NULL, NULL);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	gtk_tree_sortable_set_sort_column_id (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GTK_TYPE_TREE_SORTABLE, GtkTreeSortable), (gint) CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT, GTK_SORT_ASCENDING);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_data_->_state_ != 0) {
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		while (_data_->_task_complete_ != TRUE) {
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 822 "contact-list-store.c"
		}
	}
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_object_unref (_data_->_async_result);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return FALSE;
#line 829 "contact-list-store.c"
}


GearyContact* contact_list_store_get_contact (ContactListStore* self, GtkTreeIter* iter) {
	GearyContact* result = NULL;
	GValue contact_value = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GObject* _tmp2_;
	GearyContact* _tmp3_;
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (IS_CONTACT_LIST_STORE (self), NULL);
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = *iter;
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	gtk_tree_model_get_value (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_MODEL, GtkTreeModel), &_tmp0_, (gint) CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT, &_tmp1_);
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&contact_value) ? (g_value_unset (&contact_value), NULL) : NULL;
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_value = _tmp1_;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2_ = g_value_get_object (&contact_value);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_TYPE_CONTACT, GearyContact));
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	result = _tmp3_;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&contact_value) ? (g_value_unset (&contact_value), NULL) : NULL;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return result;
#line 862 "contact-list-store.c"
}


gchar* contact_list_store_get_rfc822_string (ContactListStore* self, GtkTreeIter* iter) {
	gchar* result = NULL;
	GtkTreeIter _tmp0_;
	GearyContact* _tmp1_;
	GearyContact* _tmp2_;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (IS_CONTACT_LIST_STORE (self), NULL);
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = *iter;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp1_ = contact_list_store_get_contact (self, &_tmp0_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2_ = _tmp1_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp3_ = geary_contact_get_rfc822_address (_tmp2_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp4_ = _tmp3_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp5_ = geary_rf_c822_mailbox_address_to_rfc822_string (_tmp4_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp6_ = _tmp5_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_object_unref0 (_tmp4_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_object_unref0 (_tmp2_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	result = _tmp6_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return result;
#line 901 "contact-list-store.c"
}


void contact_list_store_set_highlighted_result (ContactListStore* self, GtkTreeIter* iter, const gchar* highlighted_result, const gchar* current_address_key) {
	GValue prior_keys_value = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GeeHashSet* prior_keys = NULL;
	GObject* _tmp2_;
	GeeHashSet* _tmp3_;
	GeeHashSet* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (IS_CONTACT_LIST_STORE (self));
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (iter != NULL);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (highlighted_result != NULL);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (current_address_key != NULL);
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = *iter;
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	gtk_tree_model_get_value (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_MODEL, GtkTreeModel), &_tmp0_, (gint) CONTACT_LIST_STORE_COLUMN_PRIOR_KEYS, &_tmp1_);
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&prior_keys_value) ? (g_value_unset (&prior_keys_value), NULL) : NULL;
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	prior_keys_value = _tmp1_;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2_ = g_value_get_object (&prior_keys_value);
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_HASH_SET, GeeHashSet));
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	prior_keys = _tmp3_;
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp4_ = prior_keys;
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp5_ = current_address_key;
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp6_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp5_);
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (!_tmp6_) {
#line 945 "contact-list-store.c"
		GeeHashSet* _tmp7_;
		const gchar* _tmp8_;
		GtkTreeIter _tmp9_;
		const gchar* _tmp10_;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp7_ = prior_keys;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp8_ = current_address_key;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp8_);
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp9_ = *iter;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp10_ = highlighted_result;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		gtk_list_store_set (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_store_get_type (), GtkListStore), &_tmp9_, CONTACT_LIST_STORE_COLUMN_CONTACT_MARKUP_NAME, _tmp10_, -1, -1);
#line 962 "contact-list-store.c"
	}
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_object_unref0 (prior_keys);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_IS_VALUE (&prior_keys_value) ? (g_value_unset (&prior_keys_value), NULL) : NULL;
#line 968 "contact-list-store.c"
}


static inline void contact_list_store_add_contact (ContactListStore* self, GearyContact* contact) {
	GearyContact* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (IS_CONTACT_LIST_STORE (self));
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (GEARY_IS_CONTACT (contact));
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = contact;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp1_ = geary_contact_get_highest_importance (_tmp0_);
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2_ = _tmp1_;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (_tmp2_ >= ((gint) CONTACT_LIST_STORE_CONTACT_VISIBILITY_THRESHOLD)) {
#line 988 "contact-list-store.c"
		gchar* full_address = NULL;
		GearyContact* _tmp3_;
		GearyRFC822MailboxAddress* _tmp4_;
		GearyRFC822MailboxAddress* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkTreeIter iter = {0};
		GtkTreeIter _tmp8_ = {0};
		GtkTreeIter _tmp9_;
		GearyContact* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GeeHashSet* _tmp14_;
		GeeHashSet* _tmp15_;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp3_ = contact;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp4_ = geary_contact_get_rfc822_address (_tmp3_);
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp5_ = _tmp4_;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp6_ = geary_rf_c822_mailbox_address_to_rfc822_string (_tmp5_);
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp7_ = _tmp6_;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (_tmp5_);
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		full_address = _tmp7_;
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		gtk_list_store_append (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_store_get_type (), GtkListStore), &_tmp8_);
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		iter = _tmp8_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp9_ = iter;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp10_ = contact;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp11_ = full_address;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp12_ = g_markup_escape_text (_tmp11_, (gssize) -1);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp13_ = _tmp12_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp14_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp15_ = _tmp14_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		gtk_list_store_set (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_store_get_type (), GtkListStore), &_tmp9_, CONTACT_LIST_STORE_COLUMN_CONTACT_OBJECT, _tmp10_, CONTACT_LIST_STORE_COLUMN_CONTACT_MARKUP_NAME, _tmp13_, CONTACT_LIST_STORE_COLUMN_PRIOR_KEYS, _tmp15_, -1);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (_tmp15_);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (_tmp13_);
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_free0 (full_address);
#line 1044 "contact-list-store.c"
	}
}


static void contact_list_store_update_contact (ContactListStore* self, GearyContact* updated_contact) {
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (IS_CONTACT_LIST_STORE (self));
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (GEARY_IS_CONTACT (updated_contact));
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp1_ = gtk_tree_model_get_iter_first (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_MODEL, GtkTreeModel), &_tmp0_);
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	iter = _tmp0_;
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (!_tmp1_) {
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		return;
#line 1065 "contact-list-store.c"
	}
	{
		gboolean _tmp2_ = FALSE;
#line 150 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp2_ = TRUE;
#line 150 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		while (TRUE) {
#line 1073 "contact-list-store.c"
			GtkTreeIter _tmp4_;
			GearyContact* _tmp5_;
			GearyContact* _tmp6_;
			GearyContact* _tmp7_;
			gboolean _tmp8_;
			GtkTreePath* path = NULL;
			GtkTreeIter _tmp9_;
			GtkTreePath* _tmp10_;
			GtkTreePath* _tmp11_;
#line 150 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			if (!_tmp2_) {
#line 1085 "contact-list-store.c"
				gboolean _tmp3_;
#line 159 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				_tmp3_ = gtk_tree_model_iter_next (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_MODEL, GtkTreeModel), &iter);
#line 159 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				if (!_tmp3_) {
#line 159 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
					break;
#line 1093 "contact-list-store.c"
				}
			}
#line 150 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp2_ = FALSE;
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp4_ = iter;
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp5_ = contact_list_store_get_contact (self, &_tmp4_);
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp6_ = _tmp5_;
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp7_ = updated_contact;
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp8_ = _tmp6_ != _tmp7_;
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_g_object_unref0 (_tmp6_);
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			if (_tmp8_) {
#line 152 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				continue;
#line 1114 "contact-list-store.c"
			}
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp9_ = iter;
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp10_ = gtk_tree_model_get_path (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_MODEL, GtkTreeModel), &_tmp9_);
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			path = _tmp10_;
#line 155 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_tmp11_ = path;
#line 155 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			if (_tmp11_ != NULL) {
#line 1126 "contact-list-store.c"
				GtkTreePath* _tmp12_;
				GtkTreeIter _tmp13_;
#line 156 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				_tmp12_ = path;
#line 156 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				_tmp13_ = iter;
#line 156 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
				gtk_tree_model_row_changed (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_MODEL, GtkTreeModel), _tmp12_, &_tmp13_);
#line 1135 "contact-list-store.c"
			}
#line 158 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			_gtk_tree_path_free0 (path);
#line 158 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
			return;
#line 1141 "contact-list-store.c"
		}
	}
}


static void contact_list_store_on_contact_added (ContactListStore* self, GearyContact* contact) {
	GearyContact* _tmp0_;
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (IS_CONTACT_LIST_STORE (self));
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (GEARY_IS_CONTACT (contact));
#line 163 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = contact;
#line 163 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_add_contact (self, _tmp0_);
#line 1157 "contact-list-store.c"
}


static void contact_list_store_on_contact_updated (ContactListStore* self, GearyContact* contact) {
	GearyContact* _tmp0_;
#line 166 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (IS_CONTACT_LIST_STORE (self));
#line 166 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (GEARY_IS_CONTACT (contact));
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = contact;
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_update_contact (self, _tmp0_);
#line 1171 "contact-list-store.c"
}


GearyContactStore* contact_list_store_get_contact_store (ContactListStore* self) {
	GearyContactStore* result;
	GearyContactStore* _tmp0_;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_val_if_fail (IS_CONTACT_LIST_STORE (self), NULL);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = self->priv->_contact_store;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	result = _tmp0_;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	return result;
#line 1186 "contact-list-store.c"
}


static void contact_list_store_set_contact_store (ContactListStore* self, GearyContactStore* value) {
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_return_if_fail (IS_CONTACT_LIST_STORE (self));
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	if (contact_list_store_get_contact_store (self) != value) {
#line 1195 "contact-list-store.c"
		GearyContactStore* _tmp0_;
		GearyContactStore* _tmp1_;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp0_ = value;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		_g_object_unref0 (self->priv->_contact_store);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		self->priv->_contact_store = _tmp1_;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		g_object_notify ((GObject *) self, "contact-store");
#line 1208 "contact-list-store.c"
	}
}


static void contact_list_store_class_init (ContactListStoreClass * klass) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_parent_class = g_type_class_peek_parent (klass);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_type_class_add_private (klass, sizeof (ContactListStorePrivate));
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contact_list_store_get_property;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contact_list_store_set_property;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_OBJECT_CLASS (klass)->finalize = contact_list_store_finalize;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACT_LIST_STORE_CONTACT_STORE_PROPERTY, g_param_spec_object ("contact-store", "contact-store", "contact-store", GEARY_TYPE_CONTACT_STORE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1226 "contact-list-store.c"
}


static void contact_list_store_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	contact_list_store_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 1233 "contact-list-store.c"
}


static void contact_list_store_instance_init (ContactListStore * self) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	self->priv = CONTACT_LIST_STORE_GET_PRIVATE (self);
#line 13 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	self->priv->LOAD_BATCH_SIZE = (guint) 4096;
#line 1242 "contact-list-store.c"
}


static void contact_list_store_finalize (GObject * obj) {
	ContactListStore * self;
	GearyContactStore* _tmp0_;
	guint _tmp1_;
	GearyContactStore* _tmp2_;
	guint _tmp3_;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONTACT_LIST_STORE, ContactListStore);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp0_ = self->priv->_contact_store;
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_signal_parse_name ("contact-added", GEARY_TYPE_CONTACT_STORE, &_tmp1_, NULL, FALSE);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _contact_list_store_on_contact_added_geary_contact_store_contact_added, self);
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_tmp2_ = self->priv->_contact_store;
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_signal_parse_name ("contact-updated", GEARY_TYPE_CONTACT_STORE, &_tmp3_, NULL, FALSE);
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _contact_list_store_on_contact_updated_geary_contact_store_contact_updated, self);
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	_g_object_unref0 (self->priv->_contact_store);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	G_OBJECT_CLASS (contact_list_store_parent_class)->finalize (obj);
#line 1272 "contact-list-store.c"
}


GType contact_list_store_get_type (void) {
	static volatile gsize contact_list_store_type_id__volatile = 0;
	if (g_once_init_enter (&contact_list_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactListStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contact_list_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactListStore), 0, (GInstanceInitFunc) contact_list_store_instance_init, NULL };
		static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) contact_list_store_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType contact_list_store_type_id;
		contact_list_store_type_id = g_type_register_static (gtk_list_store_get_type (), "ContactListStore", &g_define_type_info, 0);
		g_type_add_interface_static (contact_list_store_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
		g_once_init_leave (&contact_list_store_type_id__volatile, contact_list_store_type_id);
	}
	return contact_list_store_type_id__volatile;
}


static void _vala_contact_list_store_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ContactListStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONTACT_LIST_STORE, ContactListStore);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	switch (property_id) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		case CONTACT_LIST_STORE_CONTACT_STORE_PROPERTY:
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		g_value_set_object (value, contact_list_store_get_contact_store (self));
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		break;
#line 1301 "contact-list-store.c"
		default:
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		break;
#line 1307 "contact-list-store.c"
	}
}


static void _vala_contact_list_store_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ContactListStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONTACT_LIST_STORE, ContactListStore);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
	switch (property_id) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		case CONTACT_LIST_STORE_CONTACT_STORE_PROPERTY:
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		contact_list_store_set_contact_store (self, g_value_get_object (value));
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		break;
#line 1323 "contact-list-store.c"
		default:
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/contact-list-store.vala"
		break;
#line 1329 "contact-list-store.c"
	}
}



