/* util-migrate.c generated by valac 0.36.12, the Vala compiler
 * generated from util-migrate.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <geary-engine.h>
#include <gio/gio.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))



#define MIGRATE_GROUP "AccountInformation"
#define MIGRATE_PRIMARY_EMAIL_KEY "primary_email"
#define MIGRATE_SETTINGS_FILENAME GEARY_ACCOUNT_INFORMATION_SETTINGS_FILENAME
#define MIGRATE_MIGRATED_FILENAME ".config_migrated"
void migrate_xdg_config_dir (GFile* user_data_dir, GFile* user_config_dir, GError** error);
#define MIGRATE_OLD_APP_ID "org.yorba.geary"
#define MIGRATE_MIGRATED_CONFIG_KEY "migrated-config"
void migrate_old_app_config (GSettings* newSettings, const gchar* old_app_id);
#define GEARY_APPLICATION_GSETTINGS_DIR _GSETTINGS_DIR
static gboolean _vala_string_array_contains (gchar* * stack, int stack_length, gchar* needle);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
     * Migrates geary.ini to the XDG configuration directory with the account's email address
     *
     * This function iterates through all the account directories in $XDG_DATA_DIR and copies over
     * geary.ini to ~/.config/geary/<account>/geary.ini. Note that it leaves the
     * original file untouched.
     * It also appends a "primary_email" key to the new configuration file to reliaby keep
     * track of the user's email address.
     */
static gpointer _g_error_copy0 (gpointer self) {
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	return self ? g_error_copy (self) : NULL;
#line 55 "util-migrate.c"
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1428 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1429 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1429 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1429 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1430 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1430 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1430 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1430 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 99 "util-migrate.c"
	}
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1431 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 105 "util-migrate.c"
}


void migrate_xdg_config_dir (GFile* user_data_dir, GFile* user_config_dir, GError** error) {
	GFile* new_config_dir = NULL;
	GFile* old_data_dir = NULL;
	GFile* new_config_file = NULL;
	GFile* old_config_file = NULL;
	GFile* _tmp4_;
	gboolean _tmp5_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp6_ = NULL;
	GFile* _tmp7_;
	GFileEnumerator* _tmp8_;
	GFileEnumerator* _tmp9_;
	GFileInfo* info = NULL;
	gchar* email = NULL;
	GFile* is_migrated = NULL;
	GError * _inner_error_ = NULL;
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	g_return_if_fail (G_IS_FILE (user_data_dir));
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	g_return_if_fail (G_IS_FILE (user_config_dir));
#line 129 "util-migrate.c"
	{
		GFile* _tmp0_;
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp0_ = user_config_dir;
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		g_file_make_directory_with_parents (_tmp0_, NULL, &_inner_error_);
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 138 "util-migrate.c"
			goto __catch127_g_error;
		}
	}
	goto __finally127;
	__catch127_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		err = _inner_error_;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_inner_error_ = NULL;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp1_ = err;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (!g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 155 "util-migrate.c"
			GError* _tmp2_;
			GError* _tmp3_;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp2_ = err;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp3_ = _g_error_copy0 (_tmp2_);
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_inner_error_ = _tmp3_;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 166 "util-migrate.c"
			goto __finally127;
		}
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_error_free0 (err);
#line 171 "util-migrate.c"
	}
	__finally127:
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		g_propagate_error (error, _inner_error_);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		return;
#line 188 "util-migrate.c"
	}
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp4_ = user_data_dir;
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	if (!_tmp5_) {
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		return;
#line 206 "util-migrate.c"
	}
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp7_ = user_data_dir;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp8_ = g_file_enumerate_children (_tmp7_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp6_ = _tmp8_;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		g_propagate_error (error, _inner_error_);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (enumerator);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		return;
#line 230 "util-migrate.c"
	}
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp9_ = _tmp6_;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp6_ = NULL;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (enumerator);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	enumerator = _tmp9_;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	while (TRUE) {
#line 242 "util-migrate.c"
		GFileInfo* _tmp10_ = NULL;
		GFileEnumerator* _tmp11_;
		GFileInfo* _tmp12_;
		GFileInfo* _tmp13_;
		GFileInfo* _tmp14_;
		GFileInfo* _tmp15_;
		GFileType _tmp16_;
		GFileInfo* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gboolean _tmp21_;
		GFile* _tmp22_;
		const gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		const gchar* _tmp26_;
		GFile* _tmp27_;
		GFile* _tmp28_;
		GFile* _tmp29_;
		GFile* _tmp30_;
		gboolean _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
		GFile* _tmp34_;
		gboolean _tmp35_;
		GFile* _tmp36_;
		gboolean _tmp37_;
		GFile* _tmp41_;
		GFile* _tmp42_;
		GFile* _tmp43_;
		gboolean _tmp44_;
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp50_;
		GKeyFile* _tmp58_;
		const gchar* _tmp59_;
		gchar* data = NULL;
		GKeyFile* _tmp60_;
		gchar* _tmp61_;
		GFile* _tmp67_;
		GFileOutputStream* _tmp68_;
		GFileOutputStream* _tmp69_;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp11_ = enumerator;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp12_ = g_file_enumerator_next_file (_tmp11_, NULL, &_inner_error_);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp10_ = _tmp12_;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error_);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			return;
#line 315 "util-migrate.c"
		}
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp13_ = _tmp10_;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp10_ = NULL;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (info);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		info = _tmp13_;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp14_ = info;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (!(_tmp14_ != NULL)) {
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			break;
#line 333 "util-migrate.c"
		}
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp15_ = info;
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp16_ = g_file_info_get_file_type (_tmp15_);
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (_tmp16_ != G_FILE_TYPE_DIRECTORY) {
#line 50 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 50 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 345 "util-migrate.c"
		}
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp17_ = info;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp18_ = g_file_info_get_name (_tmp17_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_free0 (email);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		email = _tmp19_;
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp20_ = email;
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp21_ = geary_rf_c822_mailbox_address_is_valid_address (_tmp20_);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (!_tmp21_) {
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 367 "util-migrate.c"
		}
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp22_ = user_data_dir;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp23_ = email;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp24_ = g_file_get_child (_tmp22_, _tmp23_);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		old_data_dir = _tmp24_;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp25_ = user_config_dir;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp26_ = email;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp27_ = g_file_get_child (_tmp25_, _tmp26_);
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		new_config_dir = _tmp27_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp28_ = old_data_dir;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp29_ = g_file_get_child (_tmp28_, MIGRATE_SETTINGS_FILENAME);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		old_config_file = _tmp29_;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp30_ = old_config_file;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp31_ = g_file_query_exists (_tmp30_, NULL);
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (!_tmp31_) {
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 407 "util-migrate.c"
		}
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp32_ = old_data_dir;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp33_ = g_file_get_child (_tmp32_, MIGRATE_MIGRATED_FILENAME);
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (is_migrated);
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		is_migrated = _tmp33_;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp34_ = is_migrated;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp35_ = g_file_query_exists (_tmp34_, NULL);
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (_tmp35_) {
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 427 "util-migrate.c"
		}
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp36_ = new_config_dir;
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp37_ = g_file_query_exists (_tmp36_, NULL);
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (!_tmp37_) {
#line 435 "util-migrate.c"
			{
				GFile* _tmp38_;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_tmp38_ = new_config_dir;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				g_file_make_directory_with_parents (_tmp38_, NULL, &_inner_error_);
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 444 "util-migrate.c"
					goto __catch128_g_error;
				}
			}
			goto __finally128;
			__catch128_g_error:
			{
				GError* e = NULL;
				GError* _tmp39_;
				const gchar* _tmp40_;
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				e = _inner_error_;
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_inner_error_ = NULL;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_tmp39_ = e;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_tmp40_ = _tmp39_->message;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				g_debug ("util-migrate.vala:75: Cannot make directory, %s", _tmp40_);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_error_free0 (e);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp10_);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				continue;
#line 470 "util-migrate.c"
			}
			__finally128:
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error_);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp10_);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (is_migrated);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_free0 (email);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (info);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp6_);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (enumerator);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (old_config_file);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (new_config_file);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (old_data_dir);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_g_object_unref0 (new_config_dir);
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				return;
#line 499 "util-migrate.c"
			}
		}
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp41_ = new_config_dir;
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp42_ = g_file_get_child (_tmp41_, MIGRATE_SETTINGS_FILENAME);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		new_config_file = _tmp42_;
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp43_ = new_config_file;
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp44_ = g_file_query_exists (_tmp43_, NULL);
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (_tmp44_) {
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 82 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 520 "util-migrate.c"
		}
		{
			GFile* _tmp45_;
			GFile* _tmp46_;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp45_ = old_config_file;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp46_ = new_config_file;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_file_copy (_tmp45_, _tmp46_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error_);
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 533 "util-migrate.c"
				goto __catch129_g_error;
			}
		}
		goto __finally129;
		__catch129_g_error:
		{
			GError* err = NULL;
			GFile* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			err = _inner_error_;
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_inner_error_ = NULL;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp47_ = new_config_dir;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp48_ = g_file_get_path (_tmp47_);
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp49_ = _tmp48_;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:87: Error copying over to %s", _tmp49_);
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (_tmp49_);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 564 "util-migrate.c"
		}
		__finally129:
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error_);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			return;
#line 593 "util-migrate.c"
		}
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp50_ = g_key_file_new ();
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		key_file = _tmp50_;
#line 599 "util-migrate.c"
		{
			GKeyFile* _tmp51_;
			GFile* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp51_ = key_file;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp52_ = new_config_file;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp53_ = g_file_get_path (_tmp52_);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp54_ = _tmp53_;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_key_file_load_from_file (_tmp51_, _tmp54_, G_KEY_FILE_NONE, &_inner_error_);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (_tmp54_);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 619 "util-migrate.c"
				goto __catch130_g_error;
			}
		}
		goto __finally130;
		__catch130_g_error:
		{
			GError* err = NULL;
			GFile* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			err = _inner_error_;
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_inner_error_ = NULL;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp55_ = new_config_file;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp56_ = g_file_get_path (_tmp55_);
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp57_ = _tmp56_;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:94: Error opening %s", _tmp57_);
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (_tmp57_);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 652 "util-migrate.c"
		}
		__finally130:
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error_);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			return;
#line 683 "util-migrate.c"
		}
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp58_ = key_file;
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp59_ = email;
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		g_key_file_set_value (_tmp58_, MIGRATE_GROUP, MIGRATE_PRIMARY_EMAIL_KEY, _tmp59_);
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp60_ = key_file;
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp61_ = g_key_file_to_data (_tmp60_, NULL, NULL);
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		data = _tmp61_;
#line 697 "util-migrate.c"
		{
			GFile* _tmp62_;
			const gchar* _tmp63_;
			guint8* _tmp64_;
			gint _tmp64__length1;
			guint8* _tmp65_;
			gint _tmp65__length1;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp62_ = new_config_file;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp63_ = data;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp64_ = string_get_data (_tmp63_, &_tmp64__length1);
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp65_ = _tmp64_;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp65__length1 = _tmp64__length1;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_file_replace_contents (_tmp62_, _tmp65_, (gsize) _tmp65__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error_);
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 719 "util-migrate.c"
				goto __catch131_g_error;
			}
		}
		goto __finally131;
		__catch131_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp66_;
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			e = _inner_error_;
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp66_ = email;
#line 105 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:105: Error writing email %s to config file", _tmp66_);
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_error_free0 (e);
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			continue;
#line 746 "util-migrate.c"
		}
		__finally131:
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error_);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 101 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			return;
#line 779 "util-migrate.c"
		}
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp67_ = is_migrated;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp68_ = g_file_create (_tmp67_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error_);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp69_ = _tmp68_;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (_tmp69_);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error_);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp10_);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			return;
#line 819 "util-migrate.c"
		}
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_free0 (data);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_key_file_unref0 (key_file);
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (_tmp10_);
#line 827 "util-migrate.c"
	}
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (is_migrated);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_free0 (email);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (info);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (_tmp6_);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (enumerator);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (old_config_file);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (new_config_file);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (old_data_dir);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_object_unref0 (new_config_dir);
#line 847 "util-migrate.c"
}


static gpointer _g_settings_schema_source_ref0 (gpointer self) {
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 854 "util-migrate.c"
}


static gboolean _vala_string_array_contains (gchar* * stack, int stack_length, gchar* needle) {
	int i;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	for (i = 0; i < stack_length; i++) {
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			return TRUE;
#line 866 "util-migrate.c"
		}
	}
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	return FALSE;
#line 871 "util-migrate.c"
}


void migrate_old_app_config (GSettings* newSettings, const gchar* old_app_id) {
	GSettingsSchemaSource* schemaSource = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchemaSource* _tmp1_;
	GSettingsSchema* oldSettingsSchema = NULL;
	GSettingsSchemaSource* _tmp5_;
	const gchar* _tmp6_;
	GSettingsSchema* _tmp7_;
	GSettings* _tmp8_;
	gboolean _tmp9_;
	GSettingsSchema* _tmp10_;
	GSettings* _tmp28_;
	GError * _inner_error_ = NULL;
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	g_return_if_fail (G_IS_SETTINGS (newSettings));
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	g_return_if_fail (old_app_id != NULL);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp1_ = _g_settings_schema_source_ref0 (_tmp0_);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	schemaSource = _tmp1_;
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	if (GEARY_APPLICATION_GSETTINGS_DIR != NULL) {
#line 900 "util-migrate.c"
		{
			GSettingsSchemaSource* _tmp2_ = NULL;
			GSettingsSchemaSource* _tmp3_;
			GSettingsSchemaSource* _tmp4_;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp3_ = g_settings_schema_source_new_from_directory (GEARY_APPLICATION_GSETTINGS_DIR, NULL, FALSE, &_inner_error_);
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp2_ = _tmp3_;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 911 "util-migrate.c"
				goto __catch132_g_error;
			}
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp4_ = _tmp2_;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_tmp2_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (schemaSource);
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			schemaSource = _tmp4_;
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (_tmp2_);
#line 924 "util-migrate.c"
		}
		goto __finally132;
		__catch132_g_error:
		{
			GError* e = NULL;
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			e = _inner_error_;
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_inner_error_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_error_free0 (e);
#line 936 "util-migrate.c"
		}
		__finally132:
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (schemaSource);
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error_);
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			return;
#line 949 "util-migrate.c"
		}
	}
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp5_ = schemaSource;
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp6_ = old_app_id;
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp7_ = g_settings_schema_source_lookup (_tmp5_, _tmp6_, FALSE);
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	oldSettingsSchema = _tmp7_;
#line 126 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp8_ = newSettings;
#line 126 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp9_ = g_settings_get_boolean (_tmp8_, MIGRATE_MIGRATED_CONFIG_KEY);
#line 126 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	if (_tmp9_) {
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_settings_schema_unref0 (oldSettingsSchema);
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_settings_schema_source_unref0 (schemaSource);
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		return;
#line 972 "util-migrate.c"
	}
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp10_ = oldSettingsSchema;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	if (_tmp10_ != NULL) {
#line 978 "util-migrate.c"
		GSettings* oldSettings = NULL;
		GSettingsSchema* _tmp11_;
		GSettings* _tmp12_;
		gchar** oldKeys = NULL;
		GSettings* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint oldKeys_length1;
		gint _oldKeys_size_;
		GSettings* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp11_ = oldSettingsSchema;
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp12_ = g_settings_new_full (_tmp11_, NULL, NULL);
#line 130 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		oldSettings = _tmp12_;
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp13_ = oldSettings;
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp15_ = _tmp14_ = g_settings_list_keys (_tmp13_);
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		oldKeys = _tmp15_;
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		oldKeys_length1 = _vala_array_length (_tmp14_);
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_oldKeys_size_ = oldKeys_length1;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp16_ = newSettings;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_tmp18_ = _tmp17_ = g_settings_list_keys (_tmp16_);
#line 1011 "util-migrate.c"
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			key_collection = _tmp18_;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			key_collection_length1 = _vala_array_length (_tmp17_);
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			for (key_it = 0; key_it < _vala_array_length (_tmp17_); key_it = key_it + 1) {
#line 1023 "util-migrate.c"
				gchar* _tmp19_;
				gchar* key = NULL;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				_tmp19_ = g_strdup (key_collection[key_it]);
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
				key = _tmp19_;
#line 1030 "util-migrate.c"
				{
					const gchar* _tmp20_;
					gchar** _tmp21_;
					gint _tmp21__length1;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
					_tmp20_ = key;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
					_tmp21_ = oldKeys;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
					_tmp21__length1 = oldKeys_length1;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
					if (_vala_string_array_contains (_tmp21_, _tmp21__length1, _tmp20_)) {
#line 1043 "util-migrate.c"
						GSettings* _tmp22_;
						const gchar* _tmp23_;
						GSettings* _tmp24_;
						const gchar* _tmp25_;
						GVariant* _tmp26_;
						GVariant* _tmp27_;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						_tmp22_ = newSettings;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						_tmp23_ = key;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						_tmp24_ = oldSettings;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						_tmp25_ = key;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						_tmp26_ = g_settings_get_value (_tmp24_, _tmp25_);
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						_tmp27_ = _tmp26_;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						g_settings_set_value (_tmp22_, _tmp23_, _tmp27_);
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
						_g_variant_unref0 (_tmp27_);
#line 1066 "util-migrate.c"
					}
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
					_g_free0 (key);
#line 1070 "util-migrate.c"
				}
			}
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
			key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1075 "util-migrate.c"
		}
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		oldKeys = (_vala_array_free (oldKeys, oldKeys_length1, (GDestroyNotify) g_free), NULL);
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
		_g_object_unref0 (oldSettings);
#line 1081 "util-migrate.c"
	}
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_tmp28_ = newSettings;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	g_settings_set_boolean (_tmp28_, MIGRATE_MIGRATED_CONFIG_KEY, TRUE);
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_settings_schema_unref0 (oldSettingsSchema);
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-migrate.vala"
	_g_settings_schema_source_unref0 (schemaSource);
#line 1091 "util-migrate.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1098 "util-migrate.c"
		int i;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1106 "util-migrate.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	g_free (array);
#line 1118 "util-migrate.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	if (array) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
		while (((gpointer*) array)[length]) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
			length++;
#line 1131 "util-migrate.c"
		}
	}
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	return length;
#line 1136 "util-migrate.c"
}



