/* web-process-extension.c generated by valac 0.36.12, the Vala compiler
 * generated from web-process-extension.vala, do not modify */

/*
 * Copyright 2016 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <webkit2/webkit-web-extension.h>
#include <geary-engine.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>
#include <gdk/gdk.h>
#include <JavaScriptCore/JavaScript.h>


#define TYPE_GEARY_WEB_EXTENSION (geary_web_extension_get_type ())
#define GEARY_WEB_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_WEB_EXTENSION, GearyWebExtension))
#define GEARY_WEB_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_WEB_EXTENSION, GearyWebExtensionClass))
#define IS_GEARY_WEB_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_WEB_EXTENSION))
#define IS_GEARY_WEB_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_WEB_EXTENSION))
#define GEARY_WEB_EXTENSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_WEB_EXTENSION, GearyWebExtensionClass))

typedef struct _GearyWebExtension GearyWebExtension;
typedef struct _GearyWebExtensionClass GearyWebExtensionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearyWebExtensionPrivate GearyWebExtensionPrivate;
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GearyWebExtension {
	GObject parent_instance;
	GearyWebExtensionPrivate * priv;
};

struct _GearyWebExtensionClass {
	GObjectClass parent_class;
};

struct _GearyWebExtensionPrivate {
	WebKitWebExtension* extension;
};

struct _Block1Data {
	int _ref_count_;
	GearyWebExtension* self;
	WebKitWebPage* web_page;
};


static gpointer geary_web_extension_parent_class = NULL;

void webkit_web_extension_initialize_with_user_data (WebKitWebExtension* extension, GVariant* data);
GType geary_web_extension_get_type (void) G_GNUC_CONST;
GearyWebExtension* geary_web_extension_new (WebKitWebExtension* extension);
GearyWebExtension* geary_web_extension_construct (GType object_type, WebKitWebExtension* extension);
#define GEARY_WEB_EXTENSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GEARY_WEB_EXTENSION, GearyWebExtensionPrivate))
enum  {
	GEARY_WEB_EXTENSION_0_PROPERTY
};
static void __lambda4_ (GearyWebExtension* self, WebKitWebExtension* extension, WebKitWebPage* web_page);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void geary_web_extension_on_console_message (GearyWebExtension* self, WebKitWebPage* page, WebKitConsoleMessage* message);
static void _geary_web_extension_on_console_message_webkit_web_page_console_message_sent (WebKitWebPage* _sender, WebKitConsoleMessage* console_message, gpointer self);
static gboolean geary_web_extension_on_send_request (GearyWebExtension* self, WebKitWebPage* page, WebKitURIRequest* request, WebKitURIResponse* response);
static gboolean _geary_web_extension_on_send_request_webkit_web_page_send_request (WebKitWebPage* _sender, WebKitURIRequest* request, WebKitURIResponse* redirected_response, gpointer self);
static void __lambda5_ (Block1Data* _data1_);
static void geary_web_extension_selection_changed (GearyWebExtension* self, WebKitWebPage* page);
static void ___lambda5__webkit_web_editor_selection_changed (WebKitWebEditor* _sender, gpointer self);
static void ___lambda4__webkit_web_extension_page_created (WebKitWebExtension* _sender, WebKitWebPage* web_page, gpointer self);
const gchar* webkit_console_message_level_to_string (WebKitConsoleMessageLevel self);
const gchar* webkit_console_message_source_to_string (WebKitConsoleMessageSource self);
static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle);
static gboolean geary_web_extension_should_load_remote_images (GearyWebExtension* self, WebKitWebPage* page);
static void geary_web_extension_remote_image_load_blocked (GearyWebExtension* self, WebKitWebPage* page);
static void _vala_SoupURI_free (SoupURI* self);
static JSValueRef* geary_web_extension_execute_script (GearyWebExtension* self, JSContextRef context, const gchar* script, gint line, GError** error);
static JSValueRef* _JS_value_dup (JSValueRef* self);
static void geary_web_extension_finalize (GObject * obj);

static const gchar* GEARY_WEB_EXTENSION_ALLOWED_SCHEMES[3] = {"cid", "geary", "data"};

/**
 * Initialises GearyWebExtension for WebKit web processes.
 */
void webkit_web_extension_initialize_with_user_data (WebKitWebExtension* extension, GVariant* data) {
	gboolean logging_enabled = FALSE;
	GVariant* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GearyWebExtension* instance = NULL;
	WebKitWebExtension* _tmp4_;
	GearyWebExtension* _tmp5_;
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (WEBKIT_IS_WEB_EXTENSION (extension));
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (data != NULL);
#line 13 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = data;
#line 13 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = g_variant_get_boolean (_tmp0_);
#line 13 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	logging_enabled = _tmp1_;
#line 15 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	geary_logging_init ();
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = logging_enabled;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (_tmp2_) {
#line 120 "web-process-extension.c"
		FILE* _tmp3_;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp3_ = stdout;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		geary_logging_log_to (_tmp3_);
#line 126 "web-process-extension.c"
	}
#line 19 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_debug ("web-process-extension.vala:19: Initialising...");
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp4_ = extension;
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp5_ = geary_web_extension_new (_tmp4_);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	instance = _tmp5_;
#line 23 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_object_ref (G_TYPE_CHECK_INSTANCE_CAST (instance, G_TYPE_OBJECT, GObject));
#line 11 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (instance);
#line 140 "web-process-extension.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return self ? g_object_ref (self) : NULL;
#line 147 "web-process-extension.c"
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return _data1_;
#line 156 "web-process-extension.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 165 "web-process-extension.c"
		GearyWebExtension* self;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		self = _data1_->self;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (_data1_->web_page);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (self);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_slice_free (Block1Data, _data1_);
#line 175 "web-process-extension.c"
	}
}


static void _geary_web_extension_on_console_message_webkit_web_page_console_message_sent (WebKitWebPage* _sender, WebKitConsoleMessage* console_message, gpointer self) {
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	geary_web_extension_on_console_message ((GearyWebExtension*) self, _sender, console_message);
#line 183 "web-process-extension.c"
}


static gboolean _geary_web_extension_on_send_request_webkit_web_page_send_request (WebKitWebPage* _sender, WebKitURIRequest* request, WebKitURIResponse* redirected_response, gpointer self) {
	gboolean result;
	result = geary_web_extension_on_send_request ((GearyWebExtension*) self, _sender, request, redirected_response);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return result;
#line 192 "web-process-extension.c"
}


static void __lambda5_ (Block1Data* _data1_) {
	GearyWebExtension* self;
	WebKitWebPage* _tmp0_;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	self = _data1_->self;
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = _data1_->web_page;
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	geary_web_extension_selection_changed (self, _tmp0_);
#line 205 "web-process-extension.c"
}


static void ___lambda5__webkit_web_editor_selection_changed (WebKitWebEditor* _sender, gpointer self) {
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	__lambda5_ (self);
#line 212 "web-process-extension.c"
}


static void __lambda4_ (GearyWebExtension* self, WebKitWebExtension* extension, WebKitWebPage* web_page) {
	Block1Data* _data1_;
	WebKitWebPage* _tmp0_;
	WebKitWebPage* _tmp1_;
	WebKitWebPage* _tmp2_;
	WebKitWebPage* _tmp3_;
	WebKitWebPage* _tmp4_;
	WebKitWebEditor* _tmp5_;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (WEBKIT_IS_WEB_EXTENSION (extension));
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (WEBKIT_IS_WEB_PAGE (web_page));
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_data1_->_ref_count_ = 1;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_data1_->self = g_object_ref (self);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = web_page;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (_data1_->web_page);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_data1_->web_page = _tmp1_;
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = _data1_->web_page;
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_signal_connect_object (_tmp2_, "console-message-sent", (GCallback) _geary_web_extension_on_console_message_webkit_web_page_console_message_sent, self, 0);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp3_ = _data1_->web_page;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_signal_connect_object (_tmp3_, "send-request", (GCallback) _geary_web_extension_on_send_request_webkit_web_page_send_request, self, 0);
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp4_ = _data1_->web_page;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp5_ = webkit_web_page_get_editor (_tmp4_);
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_signal_connect_data (_tmp5_, "selection-changed", (GCallback) ___lambda5__webkit_web_editor_selection_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	block1_data_unref (_data1_);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_data1_ = NULL;
#line 260 "web-process-extension.c"
}


static void ___lambda4__webkit_web_extension_page_created (WebKitWebExtension* _sender, WebKitWebPage* web_page, gpointer self) {
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	__lambda4_ ((GearyWebExtension*) self, _sender, web_page);
#line 267 "web-process-extension.c"
}


GearyWebExtension* geary_web_extension_construct (GType object_type, WebKitWebExtension* extension) {
	GearyWebExtension * self = NULL;
	WebKitWebExtension* _tmp0_;
	WebKitWebExtension* _tmp1_;
	WebKitWebExtension* _tmp2_;
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (WEBKIT_IS_WEB_EXTENSION (extension), NULL);
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	self = (GearyWebExtension*) g_object_new (object_type, NULL);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = extension;
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (self->priv->extension);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	self->priv->extension = _tmp1_;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = extension;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_signal_connect_object (_tmp2_, "page-created", (GCallback) ___lambda4__webkit_web_extension_page_created, self, 0);
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return self;
#line 294 "web-process-extension.c"
}


GearyWebExtension* geary_web_extension_new (WebKitWebExtension* extension) {
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return geary_web_extension_construct (TYPE_GEARY_WEB_EXTENSION, extension);
#line 301 "web-process-extension.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 324 "web-process-extension.c"
		glong _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 332 "web-process-extension.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 344 "web-process-extension.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
#line 1333 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 368 "web-process-extension.c"
		glong _tmp2_;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 374 "web-process-extension.c"
	} else {
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 378 "web-process-extension.c"
	}
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 382 "web-process-extension.c"
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 394 "web-process-extension.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 404 "web-process-extension.c"
	}
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 410 "web-process-extension.c"
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 424 "web-process-extension.c"
	} else {
		glong _tmp12_;
		glong _tmp13_;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 434 "web-process-extension.c"
	}
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 440 "web-process-extension.c"
		glong _tmp15_;
		glong _tmp16_;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 449 "web-process-extension.c"
	}
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 469 "web-process-extension.c"
}


static void geary_web_extension_on_console_message (GearyWebExtension* self, WebKitWebPage* page, WebKitConsoleMessage* message) {
	gchar* source = NULL;
	WebKitConsoleMessage* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	WebKitConsoleMessage* _tmp7_;
	WebKitConsoleMessageLevel _tmp8_;
	GEnumValue* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	WebKitConsoleMessage* _tmp14_;
	WebKitConsoleMessageSource _tmp15_;
	GEnumValue* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	WebKitConsoleMessage* _tmp21_;
	guint _tmp22_;
	WebKitConsoleMessage* _tmp23_;
	const gchar* _tmp24_;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (IS_GEARY_WEB_EXTENSION (self));
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (WEBKIT_IS_WEB_PAGE (page));
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (message != NULL);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = message;
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = webkit_console_message_get_source_id (_tmp0_);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	source = _tmp2_;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp4_ = source;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp5_ = geary_string_is_empty (_tmp4_);
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (_tmp5_) {
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp3_ = "unknown";
#line 521 "web-process-extension.c"
	} else {
		const gchar* _tmp6_;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp6_ = source;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp3_ = _tmp6_;
#line 528 "web-process-extension.c"
	}
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp7_ = message;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp8_ = webkit_console_message_get_level (_tmp7_);
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp9_ = g_enum_get_value (g_type_class_ref (webkit_console_message_level_get_type ()), _tmp8_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp10_ = strlen ("WEBKIT_CONSOLE_MESSAGE_LEVEL_");
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp11_ = _tmp10_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp12_ = string_substring ((_tmp9_ != NULL) ? _tmp9_->value_name : NULL, (glong) _tmp11_, (glong) -1);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp13_ = _tmp12_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp14_ = message;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp15_ = webkit_console_message_get_source (_tmp14_);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp16_ = g_enum_get_value (g_type_class_ref (webkit_console_message_source_get_type ()), _tmp15_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp17_ = strlen ("WEBKIT_CONSOLE_MESSAGE_SOURCE_");
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp18_ = _tmp17_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp19_ = string_substring ((_tmp16_ != NULL) ? _tmp16_->value_name : NULL, (glong) _tmp18_, (glong) -1);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp20_ = _tmp19_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp21_ = message;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp22_ = webkit_console_message_get_line (_tmp21_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp23_ = message;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp24_ = webkit_console_message_get_text (_tmp23_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_debug ("web-process-extension.vala:56: Console: [%s] %s %s:%u: %s", _tmp13_, _tmp20_, _tmp3_, _tmp22_, _tmp24_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_free0 (_tmp20_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_free0 (_tmp13_);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_free0 (source);
#line 574 "web-process-extension.c"
}


static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle) {
	int i;
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	for (i = 0; i < stack_length; i++) {
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
			return TRUE;
#line 586 "web-process-extension.c"
		}
	}
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return FALSE;
#line 591 "web-process-extension.c"
}


static void _vala_SoupURI_free (SoupURI* self) {
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 598 "web-process-extension.c"
}


static gboolean geary_web_extension_on_send_request (GearyWebExtension* self, WebKitWebPage* page, WebKitURIRequest* request, WebKitURIResponse* response) {
	gboolean result = FALSE;
	gboolean should_load = FALSE;
	SoupURI* uri = NULL;
	WebKitURIRequest* _tmp0_;
	const gchar* _tmp1_;
	SoupURI* _tmp2_;
	gboolean _tmp3_ = FALSE;
	SoupURI* _tmp4_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (IS_GEARY_WEB_EXTENSION (self), FALSE);
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (WEBKIT_IS_WEB_PAGE (page), FALSE);
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (WEBKIT_IS_URI_REQUEST (request), FALSE);
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail ((response == NULL) || WEBKIT_IS_URI_RESPONSE (response), FALSE);
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	should_load = FALSE;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = request;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = webkit_uri_request_get_uri (_tmp0_);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = soup_uri_new (_tmp1_);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	uri = _tmp2_;
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp4_ = uri;
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (_tmp4_ != NULL) {
#line 635 "web-process-extension.c"
		SoupURI* _tmp5_;
		const gchar* _tmp6_;
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp5_ = uri;
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp6_ = soup_uri_get_scheme (_tmp5_);
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp3_ = _vala_string_array_contains (GEARY_WEB_EXTENSION_ALLOWED_SCHEMES, G_N_ELEMENTS (GEARY_WEB_EXTENSION_ALLOWED_SCHEMES), _tmp6_);
#line 644 "web-process-extension.c"
	} else {
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp3_ = FALSE;
#line 648 "web-process-extension.c"
	}
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (_tmp3_) {
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		should_load = TRUE;
#line 654 "web-process-extension.c"
	} else {
		WebKitWebPage* _tmp7_;
		gboolean _tmp8_;
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp7_ = page;
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp8_ = geary_web_extension_should_load_remote_images (self, _tmp7_);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		if (_tmp8_) {
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
			should_load = TRUE;
#line 666 "web-process-extension.c"
		} else {
			WebKitWebPage* _tmp9_;
#line 79 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
			_tmp9_ = page;
#line 79 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
			geary_web_extension_remote_image_load_blocked (self, _tmp9_);
#line 673 "web-process-extension.c"
		}
	}
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp11_ = should_load;
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (_tmp11_) {
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp10_ = GDK_EVENT_PROPAGATE;
#line 682 "web-process-extension.c"
	} else {
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp10_ = GDK_EVENT_STOP;
#line 686 "web-process-extension.c"
	}
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	result = _tmp10_;
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	__vala_SoupURI_free0 (uri);
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return result;
#line 694 "web-process-extension.c"
}


static gboolean geary_web_extension_should_load_remote_images (GearyWebExtension* self, WebKitWebPage* page) {
	gboolean result = FALSE;
	gboolean should_load = FALSE;
	WebKitFrame* frame = NULL;
	WebKitWebPage* _tmp0_;
	WebKitFrame* _tmp1_;
	WebKitFrame* _tmp2_;
	JSGlobalContextRef context = {0};
	JSGlobalContextRef _tmp3_;
	GError * _inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (IS_GEARY_WEB_EXTENSION (self), FALSE);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (WEBKIT_IS_WEB_PAGE (page), FALSE);
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	should_load = FALSE;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = page;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = webkit_web_page_get_main_frame (_tmp0_);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	frame = _tmp2_;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp3_ = webkit_frame_get_javascript_global_context (frame);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	context = (JSGlobalContextRef) _tmp3_;
#line 726 "web-process-extension.c"
	{
		JSValueRef ret = {0};
		gint _tmp4_;
		JSValueRef* _tmp5_;
		JSValueRef* _tmp6_;
		JSValueRef _tmp7_;
		gboolean _tmp8_;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp4_ = atoi ("__LINE__");
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp5_ = geary_web_extension_execute_script (self, (JSContextRef) context, "geary.allowRemoteImages", _tmp4_, &_inner_error_);
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp6_ = _tmp5_;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp7_ = *_tmp6_;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_free0 (_tmp6_);
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		ret = _tmp7_;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 748 "web-process-extension.c"
			goto __catch0_g_error;
		}
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp8_ = JSValueToBoolean ((JSContextRef) context, ret);
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		should_load = _tmp8_;
#line 755 "web-process-extension.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		err = _inner_error_;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_inner_error_ = NULL;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp9_ = err;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp10_ = _tmp9_->message;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_debug ("web-process-extension.vala:98: Error checking PageState::allowRemoteIm" \
"ages: %s", _tmp10_);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_error_free0 (err);
#line 775 "web-process-extension.c"
	}
	__finally0:
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 780 "web-process-extension.c"
		gboolean _tmp11_ = FALSE;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (frame);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error_);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		return _tmp11_;
#line 790 "web-process-extension.c"
	}
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	result = should_load;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (frame);
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return result;
#line 798 "web-process-extension.c"
}


static void geary_web_extension_remote_image_load_blocked (GearyWebExtension* self, WebKitWebPage* page) {
	WebKitFrame* frame = NULL;
	WebKitWebPage* _tmp0_;
	WebKitFrame* _tmp1_;
	WebKitFrame* _tmp2_;
	JSGlobalContextRef context = {0};
	JSGlobalContextRef _tmp3_;
	GError * _inner_error_ = NULL;
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (IS_GEARY_WEB_EXTENSION (self));
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (WEBKIT_IS_WEB_PAGE (page));
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = page;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = webkit_web_page_get_main_frame (_tmp0_);
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	frame = _tmp2_;
#line 109 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp3_ = webkit_frame_get_javascript_global_context (frame);
#line 109 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	context = (JSGlobalContextRef) _tmp3_;
#line 826 "web-process-extension.c"
	{
		gint _tmp4_;
		JSValueRef* _tmp5_;
		JSValueRef* _tmp6_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp4_ = atoi ("__LINE__");
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp5_ = geary_web_extension_execute_script (self, (JSContextRef) context, "geary.remoteImageLoadBlocked();", _tmp4_, &_inner_error_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp6_ = _tmp5_;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_free0 (_tmp6_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 841 "web-process-extension.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		err = _inner_error_;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_inner_error_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp7_ = err;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp8_ = _tmp7_->message;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_debug ("web-process-extension.vala:116: Error calling PageState::remoteImageLo" \
"adBlocked: %s", _tmp8_);
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_error_free0 (err);
#line 863 "web-process-extension.c"
	}
	__finally1:
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (frame);
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error_);
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		return;
#line 876 "web-process-extension.c"
	}
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (frame);
#line 880 "web-process-extension.c"
}


static void geary_web_extension_selection_changed (GearyWebExtension* self, WebKitWebPage* page) {
	WebKitFrame* frame = NULL;
	WebKitWebPage* _tmp0_;
	WebKitFrame* _tmp1_;
	WebKitFrame* _tmp2_;
	JSGlobalContextRef context = {0};
	JSGlobalContextRef _tmp3_;
	GError * _inner_error_ = NULL;
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (IS_GEARY_WEB_EXTENSION (self));
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_if_fail (WEBKIT_IS_WEB_PAGE (page));
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = page;
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = webkit_web_page_get_main_frame (_tmp0_);
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	frame = _tmp2_;
#line 126 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp3_ = webkit_frame_get_javascript_global_context (frame);
#line 126 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	context = (JSGlobalContextRef) _tmp3_;
#line 908 "web-process-extension.c"
	{
		gint _tmp4_;
		JSValueRef* _tmp5_;
		JSValueRef* _tmp6_;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp4_ = atoi ("__LINE__");
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp5_ = geary_web_extension_execute_script (self, (JSContextRef) context, "geary.selectionChanged();", _tmp4_, &_inner_error_);
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp6_ = _tmp5_;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_free0 (_tmp6_);
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 923 "web-process-extension.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		err = _inner_error_;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_inner_error_ = NULL;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp7_ = err;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp8_ = _tmp7_->message;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_debug ("web-process-extension.vala:133: Error calling PageStates::selectionCha" \
"nged: %s", _tmp8_);
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_error_free0 (err);
#line 945 "web-process-extension.c"
	}
	__finally2:
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (frame);
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error_);
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		return;
#line 958 "web-process-extension.c"
	}
#line 123 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (frame);
#line 962 "web-process-extension.c"
}


static JSValueRef* _JS_value_dup (JSValueRef* self) {
	JSValueRef* dup;
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	dup = g_new0 (JSValueRef, 1);
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	memcpy (dup, self, sizeof (JSValueRef));
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return dup;
#line 974 "web-process-extension.c"
}


static gpointer __JS_value_dup0 (gpointer self) {
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	return self ? _JS_value_dup (self) : NULL;
#line 981 "web-process-extension.c"
}


static JSValueRef* geary_web_extension_execute_script (GearyWebExtension* self, JSContextRef context, const gchar* script, gint line, GError** error) {
	JSValueRef* result = NULL;
	JSStringRef js_script = {0};
	const gchar* _tmp0_;
	JSStringRef _tmp1_;
	JSStringRef js_source = {0};
	JSStringRef _tmp2_;
	JSValueRef* err = NULL;
	GError * _inner_error_ = NULL;
#line 139 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (IS_GEARY_WEB_EXTENSION (self), NULL);
#line 139 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (script != NULL, NULL);
#line 141 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp0_ = script;
#line 141 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp1_ = JSStringCreateWithUTF8CString (_tmp0_);
#line 141 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	js_script = _tmp1_;
#line 142 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_tmp2_ = JSStringCreateWithUTF8CString ("__FILE__");
#line 142 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	js_source = _tmp2_;
#line 143 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	err = NULL;
#line 1010 "web-process-extension.c"
	{
		JSValueRef ret = {0};
		JSStringRef _tmp3_;
		JSStringRef _tmp4_;
		gint _tmp5_;
		JSValueRef* _tmp6_ = NULL;
		JSValueRef _tmp7_;
		JSContextRef _tmp8_;
		JSValueRef* _tmp9_;
		JSValueRef* _tmp10_;
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp3_ = js_script;
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp4_ = js_source;
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp5_ = line;
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp7_ = JSEvaluateScript (context, _tmp3_, NULL, &_tmp4_, _tmp5_, &_tmp6_);
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_free0 (err);
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		err = _tmp6_;
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		ret = _tmp7_;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp8_ = context;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp9_ = err;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		geary_js_check_exception (_tmp8_, _tmp9_, &_inner_error_);
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1043 "web-process-extension.c"
			goto __finally3;
		}
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_tmp10_ = __JS_value_dup0 (&ret);
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		result = _tmp10_;
#line 1050 "web-process-extension.c"
		{
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
			JSStringRelease (js_script);
#line 152 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
			JSStringRelease (js_source);
#line 1056 "web-process-extension.c"
		}
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_free0 (err);
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		return result;
#line 1062 "web-process-extension.c"
	}
	__finally3:
	{
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		JSStringRelease (js_script);
#line 152 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		JSStringRelease (js_source);
#line 1070 "web-process-extension.c"
	}
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	if (_inner_error_->domain == GEARY_JS_ERROR) {
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_propagate_error (error, _inner_error_);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_free0 (err);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		return NULL;
#line 1080 "web-process-extension.c"
	} else {
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		_g_free0 (err);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error_);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
		return NULL;
#line 1090 "web-process-extension.c"
	}
#line 139 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_free0 (err);
#line 1094 "web-process-extension.c"
}


static void geary_web_extension_class_init (GearyWebExtensionClass * klass) {
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	geary_web_extension_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	g_type_class_add_private (klass, sizeof (GearyWebExtensionPrivate));
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_web_extension_finalize;
#line 1105 "web-process-extension.c"
}


static void geary_web_extension_instance_init (GearyWebExtension * self) {
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	self->priv = GEARY_WEB_EXTENSION_GET_PRIVATE (self);
#line 1112 "web-process-extension.c"
}


static void geary_web_extension_finalize (GObject * obj) {
	GearyWebExtension * self;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GEARY_WEB_EXTENSION, GearyWebExtension);
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (self->priv->extension);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/web-process/web-process-extension.vala"
	G_OBJECT_CLASS (geary_web_extension_parent_class)->finalize (obj);
#line 1124 "web-process-extension.c"
}


/**
 * A WebExtension that manages Geary-specific behaviours in web processes.
 */
GType geary_web_extension_get_type (void) {
	static volatile gsize geary_web_extension_type_id__volatile = 0;
	if (g_once_init_enter (&geary_web_extension_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyWebExtensionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_web_extension_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyWebExtension), 0, (GInstanceInitFunc) geary_web_extension_instance_init, NULL };
		GType geary_web_extension_type_id;
		geary_web_extension_type_id = g_type_register_static (G_TYPE_OBJECT, "GearyWebExtension", &g_define_type_info, 0);
		g_once_init_leave (&geary_web_extension_type_id__volatile, geary_web_extension_type_id);
	}
	return geary_web_extension_type_id__volatile;
}



