/* mime-multipart-subtype.c generated by valac 0.36.12, the Vala compiler
 * generated from mime-multipart-subtype.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;

#define GEARY_MIME_TYPE_CONTENT_TYPE (geary_mime_content_type_get_type ())
#define GEARY_MIME_CONTENT_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType))
#define GEARY_MIME_CONTENT_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentTypeClass))
#define GEARY_MIME_IS_CONTENT_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MIME_TYPE_CONTENT_TYPE))
#define GEARY_MIME_IS_CONTENT_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MIME_TYPE_CONTENT_TYPE))
#define GEARY_MIME_CONTENT_TYPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentTypeClass))

typedef struct _GearyMimeContentType GearyMimeContentType;
typedef struct _GearyMimeContentTypeClass GearyMimeContentTypeClass;

#define GEARY_MIME_TYPE_MULTIPART_SUBTYPE (geary_mime_multipart_subtype_get_type ())

typedef enum  {
	GEARY_MIME_MULTIPART_SUBTYPE_UNSPECIFIED,
	GEARY_MIME_MULTIPART_SUBTYPE_MIXED,
	GEARY_MIME_MULTIPART_SUBTYPE_ALTERNATIVE,
	GEARY_MIME_MULTIPART_SUBTYPE_RELATED
} GearyMimeMultipartSubtype;



GType geary_base_object_get_type (void) G_GNUC_CONST;
GType geary_mime_content_type_get_type (void) G_GNUC_CONST;
GType geary_mime_multipart_subtype_get_type (void) G_GNUC_CONST;
GearyMimeMultipartSubtype geary_mime_multipart_subtype_from_content_type (GearyMimeContentType* content_type, gboolean* is_unknown);
gboolean geary_mime_content_type_has_media_type (GearyMimeContentType* self, const gchar* media_type);
const gchar* geary_mime_content_type_get_media_subtype (GearyMimeContentType* self);


/**
     * Converts a {@link ContentType} into a {@link MultipartSubtype}.
     *
     * If unknown, {@link MIXED} is returned but is_unknown will be true.
     */
GearyMimeMultipartSubtype geary_mime_multipart_subtype_from_content_type (GearyMimeContentType* content_type, gboolean* is_unknown) {
	gboolean _vala_is_unknown = FALSE;
	GearyMimeMultipartSubtype result = 0;
	gboolean _tmp0_ = FALSE;
	GearyMimeContentType* _tmp1_;
	GearyMimeContentType* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GQuark _tmp10_ = 0U;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	static GQuark _tmp9_label0 = 0;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	static GQuark _tmp9_label1 = 0;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	static GQuark _tmp9_label2 = 0;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	g_return_val_if_fail ((content_type == NULL) || GEARY_MIME_IS_CONTENT_TYPE (content_type), 0);
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_tmp1_ = content_type;
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	if (_tmp1_ == NULL) {
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		_tmp0_ = TRUE;
#line 86 "mime-multipart-subtype.c"
	} else {
		GearyMimeContentType* _tmp2_;
		gboolean _tmp3_;
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		_tmp2_ = content_type;
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		_tmp3_ = geary_mime_content_type_has_media_type (_tmp2_, "multipart");
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		_tmp0_ = !_tmp3_;
#line 96 "mime-multipart-subtype.c"
	}
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	if (_tmp0_) {
#line 50 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		_vala_is_unknown = TRUE;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		result = GEARY_MIME_MULTIPART_SUBTYPE_MIXED;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		if (is_unknown) {
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
			*is_unknown = _vala_is_unknown;
#line 108 "mime-multipart-subtype.c"
		}
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		return result;
#line 112 "mime-multipart-subtype.c"
	}
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_vala_is_unknown = FALSE;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_tmp4_ = content_type;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_tmp5_ = geary_mime_content_type_get_media_subtype (_tmp4_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_tmp6_ = _tmp5_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_tmp8_ = _tmp7_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	_tmp10_ = (NULL == _tmp8_) ? 0 : g_quark_from_string (_tmp8_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	g_free (_tmp8_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	if (_tmp10_ == ((0 != _tmp9_label0) ? _tmp9_label0 : (_tmp9_label0 = g_quark_from_static_string ("mixed")))) {
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 134 "mime-multipart-subtype.c"
			default:
			{
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_MIXED;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 143 "mime-multipart-subtype.c"
				}
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 147 "mime-multipart-subtype.c"
			}
		}
	} else if (_tmp10_ == ((0 != _tmp9_label1) ? _tmp9_label1 : (_tmp9_label1 = g_quark_from_static_string ("alternative")))) {
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 153 "mime-multipart-subtype.c"
			default:
			{
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_ALTERNATIVE;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 162 "mime-multipart-subtype.c"
				}
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 166 "mime-multipart-subtype.c"
			}
		}
	} else if (_tmp10_ == ((0 != _tmp9_label2) ? _tmp9_label2 : (_tmp9_label2 = g_quark_from_static_string ("related")))) {
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 172 "mime-multipart-subtype.c"
			default:
			{
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_RELATED;
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 181 "mime-multipart-subtype.c"
				}
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 185 "mime-multipart-subtype.c"
			}
		}
	} else {
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		switch (0) {
#line 191 "mime-multipart-subtype.c"
			default:
			{
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				_vala_is_unknown = TRUE;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				result = GEARY_MIME_MULTIPART_SUBTYPE_MIXED;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				if (is_unknown) {
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
					*is_unknown = _vala_is_unknown;
#line 202 "mime-multipart-subtype.c"
				}
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
				return result;
#line 206 "mime-multipart-subtype.c"
			}
		}
	}
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
	if (is_unknown) {
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/engine/mime/mime-multipart-subtype.vala"
		*is_unknown = _vala_is_unknown;
#line 214 "mime-multipart-subtype.c"
	}
}


/**
 * A represenation of a MIME multipart Content-Type subtype.
 *
 * See [[https://tools.ietf.org/html/rfc2046#section-5.1]]
 */
GType geary_mime_multipart_subtype_get_type (void) {
	static volatile gsize geary_mime_multipart_subtype_type_id__volatile = 0;
	if (g_once_init_enter (&geary_mime_multipart_subtype_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_MIME_MULTIPART_SUBTYPE_UNSPECIFIED, "GEARY_MIME_MULTIPART_SUBTYPE_UNSPECIFIED", "unspecified"}, {GEARY_MIME_MULTIPART_SUBTYPE_MIXED, "GEARY_MIME_MULTIPART_SUBTYPE_MIXED", "mixed"}, {GEARY_MIME_MULTIPART_SUBTYPE_ALTERNATIVE, "GEARY_MIME_MULTIPART_SUBTYPE_ALTERNATIVE", "alternative"}, {GEARY_MIME_MULTIPART_SUBTYPE_RELATED, "GEARY_MIME_MULTIPART_SUBTYPE_RELATED", "related"}, {0, NULL, NULL}};
		GType geary_mime_multipart_subtype_type_id;
		geary_mime_multipart_subtype_type_id = g_enum_register_static ("GearyMimeMultipartSubtype", values);
		g_once_init_leave (&geary_mime_multipart_subtype_type_id__volatile, geary_mime_multipart_subtype_type_id);
	}
	return geary_mime_multipart_subtype_type_id__volatile;
}



